﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private lblDenSoc As Label
	Private lblCUI As Label
	Private lblAdrSediu As Label
	Private btnGenerare As Button
	Private tbv As TableView
	Private msv As SearchView
	Private cmbTipContract As ComboBox
	Private txtNrContract As TextField
	Private DPDataContract As DatePicker
	Private DPvalabilitate As DatePicker
	Private txtValContract As TextField
	Private idSocietate As String
	Private dataInceput, dataSfarsit As String
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	Main.mainTBP.LoadLayout("adauga_Contract","Adauga Contract")
	msv.SetItems(dbFunction.get_companyNameList)
	fill_tipContract
	'dialog.Initialize(base)
End Sub

Sub tbv_SelectedRowChanged(Index As Int, Row() As Object)


End Sub

Sub btnGenerare_Click

	If checked_rows=0 Then 
		fx.Msgbox(Main.MainForm,"Nu ai selectat nici un echipament din tabel","Eroare operare")
		Return
	End If
	If dbFunction.get_contract_exist(txtNrContract.Text)>0 Then
		fx.Msgbox(Main.MainForm,"Exista deja un contract cu acest numar ! ! ! ","Eroare operare")
		Return
	End If
	'Adaug  datele in tabela contract
	If txtNrContract.Text="" Then
		fx.Msgbox(Main.MainForm,"Nu ai completat numarul contractului  ! ! ! ","Eroare operare")
		Return
	End If
	If txtValContract.Text="" Then
		fx.Msgbox(Main.MainForm,"Nu ai completat valoare contractului ! ! ! ","Eroare operare")
		Return
	End If
	If dataInceput="" Then
		fx.Msgbox(Main.MainForm,"Nu ai complrtat data de incput a contractlui ! ! ! ","Eroare operare")
		Return
	End If
	If dataSfarsit="" Then
		fx.Msgbox(Main.MainForm,"Nu ai completat data de sfarsit a contractlui ! ! ! ","Eroare operare")
		Return
	End If
	If IsNumber(txtValContract.Text) = False Then
		fx.Msgbox(Main.MainForm,"Valoarea contractului trebuie sa fie numerica ! ! ! ","Eroare operare")
		Return
	End If
	If cmbTipContract.SelectedIndex =-1 Then 
		fx.Msgbox(Main.MainForm,"Nu ai selectat tipul documentului","Eroare operare")
		Return
	End If
	txtValContract.Text=NumberFormat(txtValContract.Text,0,2)
	dbFunction.add_contract(idSocietate,txtNrContract.Text,dataInceput,dataSfarsit,cmbTipContract.Value,txtValContract.Text,"Valabil")
	'obtin id-ul contractului
	Dim rs As ResultSet=dbFunction.get_contract(txtNrContract.Text)
	rs.NextRow
	dbFunction.add_anexa(rs.GetString("rowID"),rs.GetString("NrContract"),dataInceput,dataSfarsit, txtValContract.Text)

	get_checked_rows
	
	dataInceput=""
	dataSfarsit=""
	clearFields
End Sub
Sub checked_rows As Int
	Dim nrbifate As Int =0
	For i=0 To tbv.Items.Size-1
		tbv.SelectedRow=i
		Dim row() As Object=tbv.SelectedRowValues
		Dim chk As CheckBox=row(0)
		If chk.Checked=True Then 
		nrbifate=nrbifate+1
		End If 
		
	Next
	Return nrbifate
End Sub
Sub get_checked_rows
	'Citesc datele din tabela de eschipamente si le adaug in tabela de detalii contract 
	For i=0 To tbv.Items.Size-1
		tbv.SelectedRow=i
		Dim row() As Object=tbv.SelectedRowValues
		Dim chk As CheckBox=row(0)
		If chk.Checked=True Then
			Dim m As Map=chk.Tag
			'm.Initialize
			' adaugare detalii contract 
			Dim rsdc As ResultSet=dbFunction.get_detalii_anexa(txtNrContract.Text,"")
			rsdc.NextRow
			dbFunction.add_detalii_contract(rsdc.GetString("rowID"),m.Get("idSocietate"),m.Get("idFiliala"),m.Get("idEchipamente"),txtNrContract.Text,"Anexa")
		End If	
	Next
End Sub
Sub clearFields
	cmbTipContract.SelectedIndex=-1
	txtNrContract.Text=""
	txtValContract.Text=""
	lblAdrSediu.Text=""
	lblCUI.Text=""
	lblDenSoc.Text=""
	tbv.Items.Clear
End Sub
Sub msv_ItemClick (Value As String)
	Dim rs As ResultSet=dbFunction.get_details_from_companyName(Value)
	rs.NextRow
	lblDenSoc.Text=rs.GetString("DenumireSocietate")
	lblCUI.Text=rs.GetString("CIF")
	lblAdrSediu.Text=rs.GetString("AdrSediu")
	idSocietate=rs.Getstring("rowID")
	fill_table(dbFunction.get_lista_echipementePunctLucru(rs.GetString("CIF"),0))
	
End Sub
Sub fill_table (rs As ResultSet)
	tbv.Items.Clear
	tbv.SetColumns(Array As String("Select","Serie","NUI","Model","Adresa Instalare","Data Instalare","Data Achizitie"))
	Do While rs.NextRow
		Dim chk As CheckBox
		Dim m As Map
		chk.Initialize("chk")
		m.Initialize
		m.Put("idSocietate",rs.GetString("rowID"))
		m.Put("idFiliala",rs.GetString("idFiliala"))
		m.Put("idEchipamente",rs.GetString("idEchipament"))
		chk.Tag=m
		Dim row(7) As Object
		row(0)=chk
		If rs.GetString("Seria")<>Null Then
			row(1)=rs.GetString("Seria")
		End If
		If rs.GetString("NUI")<>Null Then
			row(2)=rs.GetString("NUI")
		End If
		If rs.GetString("Model")<>Null Then
			row(3)=rs.GetString("Model")
		End If
		If rs.GetString("AdresaFiliala")<>Null Then
			row(4)=rs.GetString("AdresaFiliala")
		End If
		If rs.GetString("dataInstalare")<>Null Then
			row(5)=rs.GetString("dataInstalare")
		End If
		If rs.GetString("dataVanzare")<> Null Then
			row(6)=rs.GetString("dataVanzare")
		End If
		tbv.Items.Add(row)
	Loop
End Sub

Sub DPvalabilitate_ValueChanged (Value As Long)
	DateTime.DateFormat="yyyy-MM-dd"
	dataSfarsit=DateTime.Date(Value)
End Sub

Sub DPDataContract_ValueChanged (Value As Long)
	DateTime.DateFormat="yyyy-MM-dd"
	dataInceput= DateTime.Date(Value)

	DPvalabilitate.DateTicks=DateTime.Add(Value,1,0,0) 

End Sub

Sub cmbTipContract_ValueChanged (Value As Object)
	
End Sub
Sub fill_tipContract 
	cmbTipContract.Items.Clear
	cmbTipContract.Items.AddAll(Array As String("Contract revizie anuala","Contract de service si revizie anuala"))
End Sub

