﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private btnGenerare As Button

	Private DPDataContract As DatePicker
	Private DPvalabilitate As DatePicker
	Private lblAdrSediu As Label
	Private lblCUI As Label
	Private lblDenSoc As Label
	Private msv As SearchView
	Private tbv As TableView
	Private txtValContract As TextField
	Private cmbNrContract As ComboBox
	Private mp As Map
	Private dataContract As String
	Private xui As XUI
	Private dialog As B4XDialog
	Private options As B4XListTemplate
	Private base As B4XView
	Private chk_prelungire_contract As B4XCheckBox
	Private chk_adauga_echipament As B4XCheckBox
	Private nrRanduriBifate As Int=0
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	Main.mainTBP.LoadLayout("ANEXA_CONTRACT","Anexa Contract")
	base = Main.MainForm.RootPane
	msv.SetItems(dbFunction.get_companyNameList)
	mp.Initialize
dialog.Initialize(base)
dialog.Title="Lista echipamente"
	options.Initialize
	options.AllowMultiSelection=True
	options.MultiSelectionMinimum=1
	chk_adauga_echipament.Enable=False
	chk_prelungire_contract.Enable=False
	'options.Options=Array("saa","dsadasd")
End Sub

Sub msv_ItemClick (Value As String)
	Dim rs As ResultSet=dbFunction.get_details_from_companyName(Value)
	rs.NextRow
	lblDenSoc.Text=rs.GetString("DenumireSocietate")
	lblCUI.Text=rs.GetString("CIF")
	lblAdrSediu.Text=rs.GetString("AdrSediu")
	fill_cmb(rs.GetString("CIF"))
	mp.Put("Societate",lblDenSoc.Text)
	mp.Put("cui",lblCUI.Text)
	'idSocietate=rs.Getstring("rowID")
	'fill_table(dbFunction.get_lista_echipementePunctLucru(rs.GetString("CIF"),0))
	chk_adauga_echipament.Enable=True
	chk_prelungire_contract.Enable=True
End Sub

Sub DPvalabilitate_ValueChanged (Value As Long)
	
End Sub

Sub btnGenerare_Click
	If chk_adauga_echipament.Check=False And chk_prelungire_contract.Check=False Then
		fx.Msgbox(Main.MainForm,"Nu ai selectat tipul anexei prelungire contract sau adaugare echipament","Eroare Operare")
		Return
	End If
	If nrRanduriBifate>7 Then 
		fx.Msgbox(Main.MainForm,"Pe anexa se pot introduce cel mult 7 serii de echipamente.Pt a adauga mai multe serii la finalizarea operatiunii curente reluati procedura de adaugare","Limitare numar pozitii pe Anexa")
	End If
	If cmbNrContract.SelectedIndex=-1 Then
		fx.Msgbox(Main.MainForm,"Nu ai selectat numarul de contract","Eroare operare")
		Return
	End If
	If IsNumber(txtValContract.Text )= False Then
		fx.Msgbox(Main.MainForm,"Valoarea contractului este incorecta","Eroare operare")
		Return
	End If
	Dim rs As ResultSet=dbFunction.get_contract(cmbNrContract.Value)
	rs.NextRow
	DateTime.DateFormat="yyyy-MM-dd"
	'dataSfarsit=DateTime.Date(DateTime.Now)
	'Log(DateTime.Date(DateTime.Add(DateTime.DateParse(rs.GetString("valabilitate")),1,0,0)))
	If chk_prelungire_contract.Check=True Then
		dbFunction.add_anexa(rs.GetString("rowID"),rs.GetString("NrContract"),DateTime.Date(DateTime.Now),DateTime.Date(DateTime.Add(DateTime.DateParse(rs.GetString("valabilitate")),1,0,0)), txtValContract.Text)
		' UPDATE TABEL CONTRACT CU VALOARE CONTRACT SI DATA DE EXPIRARE
		dbFunction.update_tbl_contract(DateTime.Date(DateTime.Add(DateTime.DateParse(rs.GetString("valabilitate")),1,0,0)),txtValContract.Text,rs.GetString("NrContract"))
	Else
		dbFunction.add_anexa(rs.GetString("rowID"),rs.GetString("NrContract"),DateTime.Date(DateTime.Now),DateTime.Date(DateTime.Add(DateTime.DateParse(rs.GetString("valabilitate")),0,0,0)), txtValContract.Text)
		' UPDATE TABEL CONTRACT CU VALOARE CONTRACT SI DATA DE EXPIRARE
		dbFunction.update_tbl_contract(DateTime.Date(DateTime.Add(DateTime.DateParse(rs.GetString("valabilitate")),0,0,0)),txtValContract.Text,rs.GetString("NrContract"))
	End If
	get_checked_rows
	create_Anexa_contract
	mp.Clear
	Dim fileLIst As List=File.ListFiles(File.DirApp&"\TMP")
	For i=0 To fileLIst.Size-1
		Log(fileLIst.get(i))
		Log("C:\My Documents\StartUp\Clienti\"&lblDenSoc.Text)
		File.Copy(File.DirApp&"\TMP",fileLIst.get(i),"C:\My Documents\StartUp\Clienti\"&lblDenSoc.Text,fileLIst.get(i))
		Sleep(1000)
		File.Delete(File.DirApp&"\TMP",fileLIst.get(i))
		fx.ShowExternalDocument(File.GetUri("C:\My Documents\StartUp\Clienti\"&lblDenSoc.Text,fileLIst.get(i)))
	Next
	
	clear_fields
	chk_adauga_echipament.Enable=False
	chk_prelungire_contract.Enable=False
	chk_adauga_echipament.Check=False
	chk_prelungire_contract.Check=False
End Sub
Sub nr_pozitii_bifate As Int
	For i=0 To tbv.Items.Size-1
		tbv.SelectedRow=i
		Dim row() As Object=tbv.SelectedRowValues
		Dim chk As CheckBox=row(0)
		If chk.Checked=True Then
		nrRanduriBifate=nrRanduriBifate+1
		End If
	Next
	Return nrRanduriBifate
End Sub
Sub clear_fields 
	tbv.Items.Clear
	lblDenSoc.Text=""
	lblCUI.Text=""
	lblAdrSediu.Text=""
	cmbNrContract.Items.Clear
	DPDataContract.DateTicks=0
	DPvalabilitate.DateTicks=0
	txtValContract.Text=""
End Sub
Sub cmbNrContract_ValueChanged (Value As Object)
	Log(cmbNrContract.SelectedIndex)
If cmbNrContract.SelectedIndex<>-1 Then
	Dim rs As ResultSet=dbFunction.get_detail_from_vContracte("","",Value)
	
	fill_table(rs)
		' - mutat in chk prelungire contract 
		' previw_new_expire_date(dbFunction.get_detail_from_vContracte("","",Value))
		set_current_valabiliti_date(dbFunction.get_detail_from_vContracte("","",Value))
End If 
End Sub
Sub set_current_valabiliti_date(rs As ResultSet)
	Do While rs.NextRow
		DateTime.DateFormat="yyyy-MM-dd"
		DPDataContract.DateTicks=DateTime.DateParse(rs.GetString("DataAnexa"))
		DPvalabilitate.DateTicks=DateTime.DateParse(rs.GetString("valAnexa"))
	Loop
End Sub
Sub previw_new_expire_date(rstmp As ResultSet)

	Do While	rstmp.NextRow
		DateTime.DateFormat="yyyy-MM-dd"
		DPDataContract.DateTicks= DateTime.DateParse(rstmp.GetString("valContract"))
		DPvalabilitate.DateTicks=DateTime.Add(DateTime.DateParse(rstmp.GetString("valContract")),1,0,0)
	
	Loop
End Sub

Sub chk_adauga_echipament_Click
	If chk_adauga_echipament.Check=False Then Return

	options.Options=dbFunction.get_list_of_equipments_without_contract(lblCUI.Text)
	Dim TimedTemplate As B4XTimedTemplate
	TimedTemplate.Initialize(options)
	TimedTemplate.TimeoutMilliseconds = 10000 'close after 10 seconds (this is the default value)
	Wait For (dialog.ShowTemplate(TimedTemplate, "OK", "", "CANCEL")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		dialog.Show($"You selected: ${options.SelectedItems}"$, "OK", "", "")
		For i=0 To options.SelectedItems.Size-1
			
			'Dim rs As ResultSet= dbFunction.get_details_serie_activa(options.SelectedItems.Get(i))
			'Log(options.SelectedItems.Get(i))
			add_new_equipments_to_tbl(dbFunction.get_details_serie_activa(options.SelectedItems.Get(i)))
		Next
	End If
	
	options.SelectedItems.Clear
End Sub
Sub add_new_equipments_to_tbl(rs As ResultSet)
	
	If tbv.Items.Size>0 Then
		Dim chk As CheckBox
		Dim m As Map
		rs.NextRow
		chk.Initialize("chk")
		m.Initialize
		m.Put("idSocietate",rs.GetString("rowID"))
		m.Put("idFiliala",rs.GetString("idFiliala"))
		m.Put("idEchipamente",rs.GetString("idEchipament"))
		chk.Tag=m
		Dim row(7) As Object
		chk.Checked=True
		row(0)=chk
		
		If rs.GetString("Seria")<>Null Then
			row(1)=rs.GetString("Seria")
			mp.Put("Seria",rs.GetString("Seria"))
		End If
		If rs.GetString("NUI")<>Null Then
			row(2)=rs.GetString("NUI")
		End If
		If rs.GetString("Model")<>Null Then
			row(3)=rs.GetString("Model")
			mp.Put("Model",rs.GetString("Model"))
		End If
		If rs.GetString("AdresaFiliala")<>Null Then
			row(4)=rs.GetString("AdresaFiliala")
			mp.Put("AdrInst",rs.GetString("AdresaFiliala"))
		End If
		If rs.GetString("dataInstalare")<>Null Then
			row(5)=rs.GetString("dataInstalare")
		End If
		If rs.GetString("dataVanzare")<> Null Then
			row(6)=rs.GetString("dataVanzare")
		End If
		tbv.Items.Add(row)
	End If
End Sub
Sub fill_cmb(cui As String)
	cmbNrContract.Items.Clear
	Dim rs As ResultSet= dbFunction.get_detail_from_vContracte(cui,"","")
	Do While rs.NextRow
		cmbNrContract.Items.Add(rs.GetString("NrContract"))
	Loop
End Sub
Sub get_checked_rows

	'Citesc datele din tabela de echipamente si le adaug in tabela de detalii contract
	For i=0 To tbv.Items.Size-1
		tbv.SelectedRow=i
		Dim row() As Object=tbv.SelectedRowValues
		Dim chk As CheckBox=row(0)
		If chk.Checked=True Then
			
			Dim m As Map=chk.Tag
			'm.Initialize
			' adaugare detalii contract
			DateTime.DateFormat="yyyy-MM-dd"
			Dim rsdc As ResultSet=dbFunction.get_detalii_anexa(cmbNrContract.Value,DateTime.Date(DateTime.Now))
			rsdc.NextRow
			dbFunction.add_detalii_contract(rsdc.GetString("rowID"),m.Get("idSocietate"),m.Get("idFiliala"),m.Get("idEchipamente"),cmbNrContract.Value,"Anexa")
		End If
	Next
End Sub
Sub fill_table (rs As ResultSet)
	tbv.Items.Clear
	tbv.SetColumns(Array As String("Select","Serie","NUI","Model","Adresa Instalare","Data Instalare","Data Achizitie"))
	Do While rs.NextRow
		dataContract=rs.GetString("DataContract")
		Dim chk As CheckBox
		Dim m As Map
		chk.Initialize("chk")
		m.Initialize
		m.Put("idSocietate",rs.GetString("rowID"))
		m.Put("idFiliala",rs.GetString("idFiliala"))
		m.Put("idEchipamente",rs.GetString("idEchipamente"))
		chk.Tag=m
		Dim row(7) As Object
		row(0)=chk
		If rs.GetString("Seria")<>Null Then
			row(1)=rs.GetString("Seria")
			mp.Put("Seria",rs.GetString("Seria"))
		End If
		If rs.GetString("NUI")<>Null Then
			row(2)=rs.GetString("NUI")
		End If
		If rs.GetString("Model")<>Null Then
			row(3)=rs.GetString("Model")
			mp.Put("Model",rs.GetString("Model"))
		End If
		If rs.GetString("AdresaFiliala")<>Null Then
			row(4)=rs.GetString("AdresaFiliala")
			mp.Put("AdrInst",rs.GetString("AdresaFiliala"))
		End If
		If rs.GetString("dataInstalare")<>Null Then
			row(5)=rs.GetString("dataInstalare")
		End If
		If rs.GetString("dataVanzare")<> Null Then
			row(6)=rs.GetString("dataVanzare")
		End If
		tbv.Items.Add(row)
	Loop
End Sub
Sub create_Anexa_contract
	Dim pozExcel As Int=0
	Dim fileName As String = File.DirApp&"\Template\Anexa_contract.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"TMP")=False Then
		File.MakeDir(File.DirApp,"TMP")
		File.Copy(File.DirApp,"Anexa_contract.xlsx",File.DirApp&"\TMP",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","Anexa_contract.xlsx",File.DirApp&"\TMP","Anexa_contract.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","Anexa_contract.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)
	sheet.GetRow(1).GetCell(5).ValueString=cmbNrContract.Value&"/"& dataContract
	sheet.GetRow(8).GetCell(3).ValueString=mp.Get("Societate")
	sheet.GetRow(9).GetCell(3).ValueString=mp.Get("cui")

	For i=0 To tbv.Items.Size-1
		tbv.SelectedRow=i
		Dim row() As Object=tbv.SelectedRowValues
		Dim chk As CheckBox=row(0)
		If chk.Checked=True Then
			
			'Dim m As Map=chk.Tag
			'm.Initialize
			' adaugare detalii contract
			DateTime.DateFormat="yyyy-MM-dd"
			sheet.GetRow(17+pozExcel).GetCell(0).ValueString=row(3) 'm.Get("Model")
			sheet.GetRow(17+pozExcel).GetCell(3).ValueString=row(1) 'm.Get("Seria")
			sheet.GetRow(17+pozExcel).GetCell(5).ValueString=row(4) 'm.Get("AdrInst")
			sheet.GetRow(17+pozExcel).GetCell(8).ValueString=txtValContract.Text &".00"
			pozExcel=pozExcel+3
		End If
	Next
	'sheet.GetRow(39).GetCell(0).ValueString="Data :"&DateTime.Date(DateTime.Now)
	sheet.GetRow(39).GetCell(0).ValueString="Data :"&DateTime.Date(DPDataContract.DateTicks)
	wbRep.Save(File.DirApp&"\TMP","Anexa_contract.xlsx")
	wbRep.Close
End Sub


Sub chk_prelungire_contract_Click
If cmbNrContract.SelectedIndex<>-1 Then 
	previw_new_expire_date(dbFunction.get_detail_from_vContracte("","",cmbNrContract.Value))
End If 	
End Sub