﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private tbl As TableView
	Private btnRefresh As Button
	Private cmbSelectie As ComboBox
	Private PN_month As Pane
	Private pn_from_to As Pane
	Private cmb As ComboBox
	Private DP_to As DatePicker
	Private DP_from As DatePicker
	Private txtYear As TextField
	Private btnAplica As Button
	Private cmbYears As ComboBox
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	Main.mainTBP.LoadLayout("raport_contract","Vizualizare Contacte")
	cmbSelectie.Items.AddAll(Array As String("Expirate","Expira in luna","Expira in perioada","Toate Contractele"))
	If cmbSelectie.SelectedIndex<> -1 Then
		fill_table_all_contracts(dbFunction.get_all_distinct_contract("","ASC"))
	End If
	pn_from_to.Visible=False
	PN_month.Visible=False
	fill_cmb_months
	fill_cmb_years
	cmbYears.SelectedIndex=0
	txtYear.Text=DateTime.GetYear(DateTime.Now)
End Sub
Sub fill_cmb_years
	Dim anCurent As Int = DateTime.GetYear(DateTime.Now)
	For i=0 To 2 
		cmbYears.Items.Add(anCurent+i)
	Next
End Sub

Sub fill_cmb_months
	cmb.Items.Clear
	cmb.Items.AddAll(Array As String("Ianuarie","Februarie","Martie","Aprilie","Mai","Iunie","Iulie","August","Septembrie","Octombrie","Noiembrie","Decembrie"))
End Sub

Sub fill_table_all_contracts(rs As ResultSet)
	Dim nrCrt As Int = 1
	tbl.Items.Clear
	tbl.SetColumns(Array As String("Nr.CRT","Numar Contract","Denumire Societate","Data Contract","Valabilitate Contract","Status Contract"))
	Do While rs.NextRow
		Dim row(6) As Object
		row(0)=nrCrt
		If rs.GetString("NrContract")<>Null Then
			row(1)=rs.GetString("NrContract")
		End If
		If rs.GetString("DenumireSocietate")<>Null Then
			row(2)=rs.GetString("DenumireSocietate")
		End If
		If rs.GetString("DataContract")<>Null Then
			row(3)=rs.GetString("DataContract")
		End If
		If rs.GetString("valContract")<>Null Then
			row(4)=rs.GetString("valContract")
		End If
		If rs.Getstring("denumire_status")<>Null Then
			row(5)=rs.GetString("denumire_status")
		End If
		tbl.Items.Add(row)
		nrCrt= nrCrt+1
	Loop
End Sub
Sub fill_table_expira_in_luna(rs As ResultSet)
	Dim nrCRT As Int=1
	tbl.Items.Clear
	tbl.SetColumns(Array As String("Nr.CRT","Numar Contract","Denumire Societate","Data Contract","Valabilitate Contract","Status Contract"))
	Do While rs.NextRow
		Dim row(6) As Object
		
		row(0)=nrCRT
		If rs.GetString("NrContract")<>Null Then
			row(1)=rs.GetString("NrContract")
		End If
		If rs.GetString("DenumireSocietate")<>Null Then
			row(2)=rs.GetString("DenumireSocietate")
		End If
		If rs.GetString("DataContract")<>Null Then
			
			row(3)=rs.GetString("DataContract")
		End If
		If rs.GetString("valContract")<>Null Then
			
			row(4)=rs.GetString("valContract")
		End If
		If rs.Getstring("denumire_status")<>Null Then
			
			row(5)=rs.GetString("denumire_status")
		End If
		tbl.Items.Add(row)
		nrCRT=nrCRT+1
	Loop
End Sub
Sub fill_table_expira_in_perioada(rs As ResultSet)
	Dim nrCRT As Int=1
	tbl.Items.Clear
	tbl.SetColumns(Array As String("Nr.CRT","Numar Contract","Denumire Societate","Data Contract","Valabilitate Contract","Status Contract"))
	Do While rs.NextRow
		Dim row(6) As Object
		
		row(0)=nrCRT
		If rs.GetString("NrContract")<>Null Then
			row(1)=rs.GetString("NrContract")
		End If
		If rs.GetString("DenumireSocietate")<>Null Then
			row(2)=rs.GetString("DenumireSocietate")
		End If
		If rs.GetString("DataContract")<>Null Then
			
			row(3)=rs.GetString("DataContract")
		End If
		If rs.GetString("valContract")<>Null Then
			
			row(4)=rs.GetString("valContract")
		End If
		If rs.Getstring("denumire_status")<>Null Then
			
			row(5)=rs.GetString("denumire_status")
		End If
		tbl.Items.Add(row)
		nrCRT=nrCRT+1
	Loop
End Sub
Sub fill_table_contracte_expirate(rs As ResultSet)
	Dim nrCRT As Int=1
	tbl.Items.Clear
	tbl.SetColumns(Array As String("Nr.CRT","Numar Contract","Denumire Societate","Data Contract","Valabilitate Contract","Status Contract"))
	Do While rs.NextRow
		Dim row(6) As Object
		
		row(0)=nrCRT
		If rs.GetString("NrContract")<>Null Then
			row(1)=rs.GetString("NrContract")
		End If
		If rs.GetString("DenumireSocietate")<>Null Then
			row(2)=rs.GetString("DenumireSocietate")
		End If
		If rs.GetString("DataContract")<>Null Then
			
			row(3)=rs.GetString("DataContract")
		End If
		If rs.GetString("valContract")<>Null Then
			
			row(4)=rs.GetString("valContract")
		End If
		If rs.Getstring("denumire_status")<>Null Then
			
			row(5)=rs.GetString("denumire_status")
		End If
		tbl.Items.Add(row)
		nrCRT=nrCRT+1
	Loop
End Sub

Sub btnRefresh_Click
	fill_table_all_contracts(dbFunction.get_all_distinct_contract("","Asc"))
End Sub
Sub cmbSelectie_SelectedIndexChanged(Index As Int, Value As Object)
	Select cmbSelectie.Value
		Case "Expirate"
			PN_month.Visible=False
			pn_from_to.Visible=False
			fill_table_contracte_expirate(dbFunction.get_expirated_contracts)
		Case "Toate Contractele"
			PN_month.Visible=False
			pn_from_to.Visible=False
			fill_table_all_contracts(dbFunction.get_all_distinct_contract("","ASC"))
		Case "Expira in luna"
			PN_month.Visible=True
			pn_from_to.Visible=False
		Case "Expira in perioada"
			PN_month.Visible=False
			pn_from_to.Visible=True
	End Select
End Sub

Sub DP_from_ValueChanged (Value As Long)
	
End Sub

Sub DP_to_ValueChanged (Value As Long)
	
End Sub

Sub cmb_ValueChanged (Value As Object)
	If cmb.SelectedIndex<>-1 Then 
		Dim dela, la As String
		dela =cmbYears.Value & "-" & (cmb.SelectedIndex + 1) & "-01"
		la=cmbYears.Value & "-" & (cmb.SelectedIndex + 1) & "-31"
		fill_table_contracte_expirate(dbFunction.get_contract_from_date_to_date(dela , la , 0))
	End If
End Sub

Sub btnAplica_Click
	DateTime.DateFormat="yyyy-MM-dd"
	fill_table_contracte_expirate(dbFunction.get_contract_from_date_to_date(DateTime.Date(DP_from.DateTicks) , DateTime.Date(DP_to.DateTicks) , 0))
End Sub