﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.3
@EndOfDesignText@
'Static code module
'=======================================================================================
'			page size x = 0 -> 595
'					  y = 0 -> 825
'=======================================================================================		
Sub Process_Globals
	Private fx As JFX
	Private JFX1 As JFX
	Private PDFjetConstants1 As PDFjetConstants
	Private PDFjetPDF1 As PDFjetPDF
	Private fileName As String
	Dim PDFPage As PDFjetPage
	Private no As Int=0
End Sub
Sub CreateBasePDFDocument(Title As String) As PDFjetPDF
	Dim PDFDestination As OutputStream
	fileName=Title
	PDFDestination=File.OpenOutput(File.DirApp,Title&".pdf", False)
	PDFjetPDF1.Initialize("PDFjetPDF1", PDFDestination)
	PDFjetPDF1.SetAuthor("Aplicatie bPOS")
	PDFjetPDF1.SetSubject("jPDFjet Examples")
	PDFjetPDF1.SetTitle(Title)	
	Return PDFjetPDF1
End Sub

Sub PDFjetPDF1_CloseComplete(Success As Boolean)
	If Success Then
		JFX1.ShowExternalDocument(File.GetUri(File.DirApp, fileName&".pdf"))
	Else
		Log("An error has occurred and creation of the PDF document has failed")
	End If
End Sub



Sub Create_table_report(docName As String,tv As TableView,reportingPeriod As String,title As String)
	Dim PDFjetPDF1 As PDFjetPDF=CreateBasePDFDocument(docName)
     
	Dim PDFPage As PDFjetPage
	PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)

	Dim PDFFont1 As PDFjetFont
	PDFFont1.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA_BOLD)
	PDFFont1.SetSize(7)
     
	Dim PDFFont2 As PDFjetFont
	PDFFont2.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA)
	PDFFont2.SetSize(7)
     
	Dim PDFFont3 As PDFjetFont
	PDFFont3.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.TIMES_ROMAN)
	PDFFont3.SetSize(7)
	
	Dim PDFFont_DocTitle As PDFjetFont
	PDFFont_DocTitle.Initialize(PDFjetPDF1,PDFjetConstants1.CoreFont.TIMES_BOLD_ITALIC)
	PDFFont_DocTitle.SetSize(10)
	
	Dim PDF_DocTitle As PDFjetTextLine
	PDF_DocTitle.Initialize(PDFFont_DocTitle)
	PDF_DocTitle.SetPosition(20, 6+PDFFont1.GetHeight)
	PDF_DocTitle.SetText(title.ToUpperCase)
	PDF_DocTitle.DrawOn(PDFPage)
	
	Dim line As PDFjetLine
	line.Initialize(10,20,585,20)
	line.SetWidth(1.1)
	line.DrawOn(PDFPage)
	
	Dim PDF_TimeStamp As PDFjetTextLine
	PDF_TimeStamp.Initialize(PDFFont3)
	PDF_TimeStamp.SetPosition(20, 830+PDFFont1.GetHeight)
	PDF_TimeStamp.SetText("Document Generat la : "&DateTime.date(DateTime.Now)&"  "&DateTime.Time(DateTime.Now))
	PDF_TimeStamp.DrawOn(PDFPage)
	
	Dim PDF_PageNo As PDFjetTextLine
	
	PDF_PageNo.Initialize(PDFFont3)
	PDF_PageNo.SetPosition(560, 830+PDFFont1.GetHeight)
	'PDF_PageNo.SetText("Pag :"& no)
	PDF_PageNo.DrawOn(PDFPage)
	
	If reportingPeriod<>"" Then
		Dim PDF_repPeriod As PDFjetTextLine
		PDF_repPeriod.Initialize(PDFFont3)
		PDF_repPeriod.SetPosition(20, 20+PDFFont1.GetHeight)
		PDF_repPeriod.SetText(reportingPeriod)
		PDF_repPeriod.DrawOn(PDFPage)
	End If
	Dim PDFTable As PDFjetTable
	PDFTable.Initialize
	Dim TableData1 As PDFjetTableData
	TableData1.Initialize
	Dim i As Int
	Dim PDFCell As PDFjetCell
	Dim hRow As PDFjetCellList
	Dim Row As PDFjetCellList
	Dim h(tv.ColumnsCount) As String
	For c=0 To tv.ColumnsCount-1
		h(c)=tv.GetColumnHeader(c)
	Next
	hRow.Initialize
	For x=0 To h.Length-1
		PDFCell.Initialize2(PDFFont1,h(x) )
		PDFCell.SetBottomPadding(2)
		PDFCell.SetLeftPadding(2)
		PDFCell.SetRightPadding(2)
		PDFCell.SetTopPadding(2)
		hRow.Add(PDFCell)
		Log(hRow)
	Next
	TableData1.AddRow(hRow)
	For i=0 To tv.Items.Size-1
		Row.Initialize
		Dim rowElementsList() As Object=tv.Items.Get(i)
		For r=0 To rowElementsList.Length-1
			PDFCell.Initialize2(PDFFont2,rowElementsList(r) )
			PDFCell.SetBottomPadding(2)
			PDFCell.SetLeftPadding(2)
			PDFCell.SetRightPadding(2)
			PDFCell.SetTopPadding(2)
			Row.Add(PDFCell)
		Next
		TableData1.AddRow(Row)
	Next
	PDFTable.SetData2(TableData1, PDFTable.DATA_HAS_2_HEADER_ROWS)
	PDFTable.SetCellBordersWidth(0.2)
	PDFTable.SetPosition(20, 30)
	'PDFTable.SetTextColorInRow(6, PDFjetConstants1.Color.blue)
	'PDFTable.AutoAdjustColumnWidths
	
	PDFTable.SetColumnWidth(0, 60)
	PDFTable.SetColumnWidth(1, 15)
	PDFTable.SetColumnWidth(2, 40)
	PDFTable.SetColumnWidth(3, 100)
	PDFTable.SetColumnWidth(4, 380)
	'    PDFTable.RightAlignNumbers
     
	'    here you can see two different ways to render a table that will span more than one page in the PDF document
	'    comment/uncomment each block of code and you'll see the same results
     
	'    Dim NumberOfPages As Int=PDFTable.GetNumberOfPages(PDFPage)
	'    For i=1 To NumberOfPages
	'        PDFTable.DrawOn(PDFPage)
	'        PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
	'    Next
     
	Do While PDFTable.HasMoreData
		PDF_DocTitle.DrawOn(PDFPage)
		line.DrawOn(PDFPage)
		If reportingPeriod<>"" Then  PDF_repPeriod.DrawOn(PDFPage)
		PDFTable.DrawOn(PDFPage)
		PDF_TimeStamp.DrawOn(PDFPage)
		no=no+1
		PDF_PageNo.SetText("Pag :" & no)
		PDF_PageNo.DrawOn(PDFPage)
		PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
	Loop
     no=0
	PDFjetPDF1.Close
End Sub

Sub raportCasier(docName As String,tv1 As TableView,tv2 As TableView,reportingPeriod As String)
	Dim maxRowNo As Int=1
	
	Dim PDFjetPDF1 As PDFjetPDF=CreateBasePDFDocument(docName)
     
	Dim PDFPage As PDFjetPage
	PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)

	Dim PDFFont1 As PDFjetFont
	PDFFont1.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA_BOLD)
	PDFFont1.SetSize(10)
     
	Dim PDFFont2 As PDFjetFont
	PDFFont2.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA)
	PDFFont2.SetSize(10)
     
	Dim PDFFont3 As PDFjetFont
	PDFFont3.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.TIMES_ROMAN)
	PDFFont3.SetSize(10)
	
	Dim PDFFont_DocTitle As PDFjetFont
	PDFFont_DocTitle.Initialize(PDFjetPDF1,PDFjetConstants1.CoreFont.TIMES_BOLD_ITALIC)
	PDFFont_DocTitle.SetSize(10)
	
	Dim PDF_DocTitle As PDFjetTextLine
	PDF_DocTitle.Initialize(PDFFont_DocTitle)
	PDF_DocTitle.SetPosition(20, 6+PDFFont1.GetHeight)
	PDF_DocTitle.SetText("RAPORT CAISER")
	PDF_DocTitle.DrawOn(PDFPage)
	
	Dim line As PDFjetLine
	line.Initialize(10,20,585,20)
	line.SetWidth(1.1)
	line.DrawOn(PDFPage)
	
	Dim PDF_TimeStamp As PDFjetTextLine
	PDF_TimeStamp.Initialize(PDFFont3)
	PDF_TimeStamp.SetPosition(20, 830+PDFFont1.GetHeight)
	PDF_TimeStamp.SetText("Document Generat la : "&DateTime.date(DateTime.Now)&"  "&DateTime.Time(DateTime.Now))
	PDF_TimeStamp.DrawOn(PDFPage)
	
	Dim PDF_PageNo As PDFjetTextLine
	
	PDF_PageNo.Initialize(PDFFont3)
	PDF_PageNo.SetPosition(560, 830+PDFFont1.GetHeight)
	'PDF_PageNo.SetText("Pag :"& no)
	PDF_PageNo.DrawOn(PDFPage)
	
	If reportingPeriod<>"" Then
		Dim PDF_repPeriod As PDFjetTextLine
		PDF_repPeriod.Initialize(PDFFont3)
		PDF_repPeriod.SetPosition(20, 20+PDFFont1.GetHeight)
		PDF_repPeriod.SetText(reportingPeriod)
		PDF_repPeriod.DrawOn(PDFPage)
	End If
	
	Dim PDFTable As PDFjetTable
	PDFTable.Initialize
	Dim TableData1 As PDFjetTableData
	TableData1.Initialize
	Dim i As Int
	Dim PDFCell As PDFjetCell
	Dim hRow As PDFjetCellList
	Dim Row As PDFjetCellList
	
	Dim h(tv1.ColumnsCount+tv2.ColumnsCount) As String
	Dim c As Int =1
	For c1=0 To tv1.ColumnsCount-1
		h(c1)=tv1.GetColumnHeader(c1)
		c=c+c1
	Next
	For c2=0 To tv2.ColumnsCount-1
		h(c2+c)=tv2.GetColumnHeader(c2)
	Next
	hRow.Initialize
	
	For x=0 To h.Length-1
		PDFCell.Initialize2(PDFFont1,h(x) )
		PDFCell.SetBottomPadding(2)
		PDFCell.SetLeftPadding(2)
		PDFCell.SetRightPadding(2)
		PDFCell.SetTopPadding(2)
		hRow.Add(PDFCell)
		'Log(hRow)
	Next
	TableData1.AddRow(hRow)
	If tv1.Items.Size>tv2.Items.Size Then 
		maxRowNo=tv1.Items.Size-1
	Else
		maxRowNo=tv2.Items.Size-1
	End If
	For i=0 To maxRowNo
		Row.Initialize
		Log(tv1.Items.Size-1)
		Log(i)
		If i<=tv1.Items.Size-1 Then
			Dim rowElementsList1() As Object=tv1.Items.Get(i)
		Else 
			Dim rowElementsList1() As Object=Array As String("","")
		End If 
		For r1=0 To rowElementsList1.Length-1
			PDFCell.Initialize2(PDFFont2,rowElementsList1(r1) )
			PDFCell.SetBottomPadding(2)
			PDFCell.SetLeftPadding(2)
			PDFCell.SetRightPadding(2)
			PDFCell.SetTopPadding(2)
			Row.Add(PDFCell)
		Next
		If i<=tv2.Items.Size-1 Then
			Dim rowElementsList2() As Object=tv2.Items.Get(i)
		Else
			Dim rowElementsList2() As Object=Array As String("","")
		End If
		For r2=0 To rowElementsList2.Length-1
			PDFCell.Initialize2(PDFFont2,rowElementsList2(r2) )
			PDFCell.SetBottomPadding(2)
			PDFCell.SetLeftPadding(2)
			PDFCell.SetRightPadding(2)
			PDFCell.SetTopPadding(2)
			Row.Add(PDFCell)
		Next
		
		TableData1.AddRow(Row)
	Next
	PDFTable.SetData2(TableData1, PDFTable.DATA_HAS_2_HEADER_ROWS)
	PDFTable.SetCellBordersWidth(0.2)
	PDFTable.SetPosition(70, 30)
	'PDFTable.SetTextColorInRow(6, PDFjetConstants1.Color.blue)
	PDFTable.AutoAdjustColumnWidths    
	Do While PDFTable.HasMoreData
		PDF_DocTitle.DrawOn(PDFPage)
		line.DrawOn(PDFPage)
		If reportingPeriod<>"" Then  PDF_repPeriod.DrawOn(PDFPage)
		PDFTable.DrawOn(PDFPage)
		PDF_TimeStamp.DrawOn(PDFPage)
		no=no+1
		PDF_PageNo.SetText("Pag :" & no)
		PDF_PageNo.DrawOn(PDFPage)
		PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
	Loop
	no=0
	PDFjetPDF1.Close
End Sub
Sub create_Invoice(tv As TableView,customerdata As ResultSet,myCompanyData As Map,docName As String )
	Dim nrofpg As Int=1
	
	Dim PDFjetPDF1 As PDFjetPDF=CreateBasePDFDocument(docName)
     
	Dim PDFPage As PDFjetPage
	PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)

	Dim PDFFont1 As PDFjetFont
	PDFFont1.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA_BOLD)
	PDFFont1.SetSize(12)
     
	Dim PDFFont2 As PDFjetFont
	PDFFont2.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA)
	PDFFont2.SetSize(12)
     
	Dim PDFFont3 As PDFjetFont
	PDFFont3.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.TIMES_ROMAN)
	PDFFont3.SetSize(10)
	
	Dim PDFFont_DocTitle As PDFjetFont
	PDFFont_DocTitle.Initialize(PDFjetPDF1,PDFjetConstants1.CoreFont.TIMES_BOLD_ITALIC)
	PDFFont_DocTitle.SetSize(14)
	For Color=1 To 3
	
		'========================================================================================================
'						DATE FIRMA EMITENT FACTURA 
		'========================================================================================================
		Dim Logo As PDFjetImage
		Logo.Initialize(PDFjetPDF1, File.OpenInput(File.DirApp, "logo.jpg"), PDFjetConstants1.ImageType.JPG)
		Logo.SetPosition(40,5)
		Logo.ScaleBy(0.5)
		Logo.DrawOn(PDFPage)
	
		Dim PDF_DateFirma As PDFjetTextLine
		PDF_DateFirma.Initialize(PDFFont3)
		PDF_DateFirma.SetPosition(40, 25+PDFFont1.GetHeight)
		Dim densoc As String=myCompanyData.Get("Denumire Societate")
		PDF_DateFirma.SetText(densoc.ToUpperCase)
		PDF_DateFirma.DrawOn(PDFPage)
		PDF_DateFirma.SetPosition(40, 35+PDFFont1.GetHeight)
		PDF_DateFirma.SetText("Nr.Inreg.Fiscala :"&myCompanyData.Get("cui"))
		PDF_DateFirma.DrawOn(PDFPage)
		PDF_DateFirma.SetPosition(40, 45+PDFFont1.GetHeight)
		PDF_DateFirma.SetText("Reg.Com.Nr. :"&myCompanyData.Get("NRInregistrare"))
		PDF_DateFirma.DrawOn(PDFPage)
		PDF_DateFirma.SetPosition(40, 55+PDFFont1.GetHeight)
		PDF_DateFirma.SetText("Banca :"&myCompanyData.Get("Banca"))
		PDF_DateFirma.DrawOn(PDFPage)
		PDF_DateFirma.SetPosition(40, 65+PDFFont1.GetHeight)
		PDF_DateFirma.SetText("Cont IBAN :"&myCompanyData.Get("ContBanca"))
		PDF_DateFirma.DrawOn(PDFPage)
	
		Dim StripeWidth As Float=25
		Dim Stripe As PDFjetLine
		Stripe.Initialize(5, 110, 590, 110)
		Stripe.SetWidth(StripeWidth)
		Select Color
			Case 1
				Stripe.SetColor(PDFjetConstants1.Color.royalblue)
			Case 2
			
				Dim PDFPage As PDFjetPage
				PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
				Stripe.SetColor(PDFjetConstants1.Color.red)
			Case 3
				Dim PDFPage As PDFjetPage
				PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
				Stripe.SetColor(PDFjetConstants1.Color.green)
		End Select
		
		Stripe.DrawOn(PDFPage)
	
		Dim PDF_DocTitle As PDFjetTextLine
		PDF_DocTitle.Initialize(PDFFont_DocTitle)
		PDF_DocTitle.SetPosition(40, 100+PDFFont1.GetHeight)
		PDF_DocTitle.SetColor(PDFjetConstants1.Color.white)
		PDF_DocTitle.SetText("FACTURA FISCALA NUMARUL ")
		PDF_DocTitle.DrawOn(PDFPage)
	
		Dim line As PDFjetLine
'	line.Initialize(10,20,585,20)
'	line.SetWidth(1.1)
'	line.DrawOn(PDFPage)
	
'		Dim PDF_TimeStamp As PDFjetTextLine
'		PDF_TimeStamp.Initialize(PDFFont3)
'		PDF_TimeStamp.SetPosition(20, 830+PDFFont1.GetHeight)
'		PDF_TimeStamp.SetText("Document Generat la : "&DateTime.date(DateTime.Now)&"  "&DateTime.Time(DateTime.Now))
'		PDF_TimeStamp.DrawOn(PDFPage)
'	
'		For i=1 To nrofpg
'			Dim PDFPage As PDFjetPage
'			PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
'			Dim PDF_TimeStamp As PDFjetTextLine
'			PDF_TimeStamp.Initialize(PDFFont3)
'			PDF_TimeStamp.SetPosition(20, 700+PDFFont1.GetHeight)
'			PDF_TimeStamp.SetText("Document Generat la : "&DateTime.date(DateTime.Now)&"  "&DateTime.Time(DateTime.Now))
'			PDF_TimeStamp.DrawOn(PDFPage)
'		
'		Next
	Next

	PDFjetPDF1.Close
End Sub


Sub newInvoice(docname As String,nrfact As String,DATA As String,myCompanyData As Map,customerData As Map,tv As TableView)
	Dim PDFjetPDF1 As PDFjetPDF=CreateBasePDFDocument(docname)

	Dim nrOfsets As Int =3
	Dim pagePerSet As Int
	Dim rpp As Int=15 ' ROW Per Page
	Dim yPos As Int =170
	If tv.Items.Size Mod rpp =0 Then
		pagePerSet=  tv.Items.Size/rpp
	Else
		pagePerSet= (tv.Items.Size/rpp) +1
	End If
	'TOTnrOFpages/3
	Dim PDFFont1 As PDFjetFont
	PDFFont1.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA_BOLD)
	PDFFont1.SetSize(12)
     
	Dim PDFFont2 As PDFjetFont
	PDFFont2.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA)
	PDFFont2.SetSize(12)
     
	Dim PDFFont3 As PDFjetFont
	PDFFont3.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.TIMES_ROMAN)
	PDFFont3.SetSize(10)
	
	Dim PDFFont_DocTitle As PDFjetFont
	PDFFont_DocTitle.Initialize(PDFjetPDF1,PDFjetConstants1.CoreFont.TIMES_BOLD_ITALIC)
	PDFFont_DocTitle.SetSize(14)
	
	Dim PDFFont4 As PDFjetFont
	PDFFont4.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA_BOLD)
	PDFFont4.SetSize(8)
	Dim line As PDFjetLine
	
'	line.Initialize(10,20,585,20)
'	line.SetWidth(1.1)
'	line.DrawOn(PDFPage)

	For i=1 To nrOfsets
		Dim curPage As Int =0
		Dim TG As Float
		'Dim PDFPage As PDFjetPage
		'PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
		For p=0 To pagePerSet-1
			Dim TN,TB As Float
			' ic Item counter per page , it is used to step the row in page , at the beginig of a new page it became 0
			Dim ic As Int =0
			'rpp=3
			Log("P:"&p)
			Dim PDFPage As PDFjetPage
			PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
			'========================================================================================================
'						DATE FIRMA EMITENTA FACTURA / DATE FIRMA CUMPARATOR
			'========================================================================================================
			Dim Logo As PDFjetImage
			Logo.Initialize(PDFjetPDF1, File.OpenInput(File.DirApp, "logo.jpg"), PDFjetConstants1.ImageType.JPG)
			Logo.SetPosition(40,5)
			Logo.ScaleBy(0.5)
			Logo.DrawOn(PDFPage)
	
			Dim PDF_DateFirma As PDFjetTextLine
			PDF_DateFirma.Initialize(PDFFont3)
			PDF_DateFirma.SetPosition(40, 25+PDFFont1.GetHeight)
			Dim densoc As String=myCompanyData.Get("Denumire Societate")
			PDF_DateFirma.SetText(densoc.ToUpperCase)
			PDF_DateFirma.DrawOn(PDFPage)
			PDF_DateFirma.SetPosition(40, 35+PDFFont1.GetHeight)
			PDF_DateFirma.SetText("Nr.Inreg.Fiscala :"&myCompanyData.Get("cui"))
			PDF_DateFirma.DrawOn(PDFPage)
			PDF_DateFirma.SetPosition(40, 45+PDFFont1.GetHeight)
			PDF_DateFirma.SetText("Reg.Com.Nr. :"&myCompanyData.Get("NRInregistrare"))
			PDF_DateFirma.DrawOn(PDFPage)
			PDF_DateFirma.SetPosition(40, 55+PDFFont1.GetHeight)
			PDF_DateFirma.SetText("Banca :"&myCompanyData.Get("Banca"))
			PDF_DateFirma.DrawOn(PDFPage)
			PDF_DateFirma.SetPosition(40, 65+PDFFont1.GetHeight)
			PDF_DateFirma.SetText("Cont IBAN :"&myCompanyData.Get("ContBanca"))
			PDF_DateFirma.DrawOn(PDFPage)
			'========================================================================================================
'												 DATE FIRMA CUMPARATOR
			'========================================================================================================
			Dim PDF_CustomerData As PDFjetTextLine
			PDF_CustomerData.Initialize(PDFFont3)
			PDF_CustomerData.SetPosition(400, 25+PDFFont1.GetHeight)
			Dim densoc As String=customerData.Get("Beneficiar")
			PDF_CustomerData.SetText(densoc.ToUpperCase)
			PDF_CustomerData.DrawOn(PDFPage)
			PDF_CustomerData.SetPosition(400, 35+PDFFont1.GetHeight)
			PDF_CustomerData.SetText("Nr.Inreg.Fiscala :"&customerData.Get("cui"))
			PDF_CustomerData.DrawOn(PDFPage)
			PDF_CustomerData.SetPosition(400, 45+PDFFont1.GetHeight)
			PDF_CustomerData.SetText("Reg.Com.Nr. :"&customerData.Get("regcomert"))
			PDF_CustomerData.DrawOn(PDFPage)
			PDF_CustomerData.SetPosition(400, 55+PDFFont1.GetHeight)
			PDF_CustomerData.SetText("Banca :"&customerData.Get("banca"))
			PDF_CustomerData.DrawOn(PDFPage)
			PDF_CustomerData.SetPosition(400, 65+PDFFont1.GetHeight)
			PDF_CustomerData.SetText("Cont IBAN :"&customerData.Get("iban"))
			PDF_CustomerData.DrawOn(PDFPage)
			
			
			Dim StripeWidth As Float=25
			Dim Stripe As PDFjetLine
			Stripe.Initialize(5, 110, 590, 110)
			Stripe.SetWidth(StripeWidth)
			Dim PDF_DocTitle As PDFjetTextLine
			Select i
				Case 1
					Stripe.SetColor(PDFjetConstants1.Color.royalblue)
				Case 2
			
					Stripe.SetColor(PDFjetConstants1.Color.red)
				Case 3
					Stripe.SetColor(PDFjetConstants1.Color.green)
			End Select
			Stripe.DrawOn(PDFPage)
			PDF_DocTitle.Initialize(PDFFont_DocTitle)
			PDF_DocTitle.SetPosition(40, 100+PDFFont1.GetHeight)
			PDF_DocTitle.SetColor(PDFjetConstants1.Color.white)
			Log(data)
			PDF_DocTitle.SetText($"FACTURA FISCALA : ${nrfact}/${DATA}"$)
			PDF_DocTitle.DrawOn(PDFPage)
			'========================================================================================================
'						ADAUGARE Header Tabel articole
			'========================================================================================================
			'linie sub capul tabel
			line.Initialize(10,150,585,150)
			line.SetColor(PDFjetConstants1.Color.black)
			line.SetWidth(1.1)
			line.DrawOn(PDFPage)
			'linie la final de articole
			line.Initialize(10,740,585,740)
			line.SetColor(PDFjetConstants1.Color.black)
			line.SetWidth(1.1)
			line.DrawOn(PDFPage)
			Dim headerTabel As PDFjetTextLine
			headerTabel.Initialize(PDFFont4)
			headerTabel.SetColor(PDFjetConstants1.Color.black)
			headerTabel.SetPosition(40,135)
			headerTabel.SetText("Nr. Crt")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(70,135)
			headerTabel.SetText("Cod Articol")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(130,135)
			headerTabel.SetText("Denumire Articol")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(250,135)
			headerTabel.SetText("Cantitate")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(290,135)
			headerTabel.SetText("U.M.")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(320,135)
			headerTabel.SetText("Pret Unitar")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(320,145)
			headerTabel.SetText("fara TVA")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(400,135)
			headerTabel.SetText("Valoare")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(480,135)
			headerTabel.SetText("Val.TVA")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(540,135)
			headerTabel.SetText("TVA%")
			headerTabel.DrawOn(PDFPage)
			
			'========================================================================================================
'						ADAUGARE LINII ARTICOLE 
			'========================================================================================================
			Dim itemLine As PDFjetTextLine
			Dim yPos As Int =160
			itemLine.Initialize(PDFFont3)
			'calculate the last item number = counter
'			If tv.Items.Size< (p*rpp+rpp) Then
'				rpp=tv.Items.Size Mod rpp
'			End If
			Dim counter,beginCounter ,EndCounter As Int
			If rpp > tv.Items.Size Then
				EndCounter = tv.Items.Size-1
			Else
				If pagePerSet-1>p Then
					counter=(p*rpp)
					beginCounter=p*rpp
					EndCounter=(rpp*p)+rpp-1
				Else
					beginCounter=p*rpp
					EndCounter=p*rpp+(tv.Items.Size Mod rpp) -1
				End If
					
			End If
			For r=beginCounter To EndCounter
				Dim rowELEMENTS() As Object= tv.Items.Get(r)
				'Log(r)
				'Log(tv.Items.Get(r))
				'For e=0 To rowELEMENTS.Length-1
				'	NR CRT
				itemLine.SetPosition(40,yPos+(ic*11))
				itemLine.SetColor(PDFjetConstants1.Color.black)
				itemLine.SetText(rowELEMENTS(0))
				itemLine.DrawOn(PDFPage)
				'	COD ARTICOL
				itemLine.SetPosition(70,yPos+(ic*11))
				itemLine.SetColor(PDFjetConstants1.Color.black)
				itemLine.SetText(rowELEMENTS(1))
				itemLine.DrawOn(PDFPage)
				'	DENUMIRE ARTICOL
				itemLine.SetPosition(130,yPos+(ic*11))
				itemLine.SetColor(PDFjetConstants1.Color.black)
				itemLine.SetText(rowELEMENTS(2))
				itemLine.DrawOn(PDFPage)
				'	CANTITATE
				itemLine.SetPosition(250,yPos+(ic*11))
				itemLine.SetColor(PDFjetConstants1.Color.black)
				itemLine.SetText(rowELEMENTS(3))
				itemLine.DrawOn(PDFPage)
				'	UNITATE DE MASURA
				itemLine.SetPosition(290,yPos+(ic*11))
				itemLine.SetColor(PDFjetConstants1.Color.black)
				itemLine.SetText(rowELEMENTS(4))
				itemLine.DrawOn(PDFPage)
				'	PRET UNITAR
				itemLine.SetPosition(320,yPos+(ic*11))
				itemLine.SetColor(PDFjetConstants1.Color.black)
				itemLine.SetText(rowELEMENTS(5))
				itemLine.DrawOn(PDFPage)
				'	TOTAL NET
				itemLine.SetPosition(400,yPos+(ic*11))
				itemLine.SetColor(PDFjetConstants1.Color.black)
				itemLine.SetText(rowELEMENTS(6))
				itemLine.DrawOn(PDFPage)
				'	TOTAL BRUT
				itemLine.SetPosition(480,yPos+(ic*11))
				itemLine.SetColor(PDFjetConstants1.Color.black)
				itemLine.SetText(rowELEMENTS(7))
				itemLine.DrawOn(PDFPage)
				' 	TVA
				itemLine.SetPosition(540,yPos+(ic*11))
				itemLine.SetColor(PDFjetConstants1.Color.black)
				itemLine.SetText(rowELEMENTS(8))
				itemLine.DrawOn(PDFPage)
				'Adauga linie dupa fiecare articol
				'Log("10 ,"&(yPos+PDFFont3.GetHeight+(ic*11))&" , 585 ,"&(yPos+PDFFont3.GetHeight+(ic*11)))
				'line.Initialize(10,yPos+PDFFont3.GetHeight+(ic*11),585,yPos+PDFFont3.GetHeight+(ic*11))
				line.Initialize(10,yPos+1+(ic*11),585,yPos+1+(ic*11))
				line.SetColor(PDFjetConstants1.Color.gray)
				line.SetWidth(0.1)
				line.DrawOn(PDFPage)
				'Next
				TN=TN+rowELEMENTS(6)
				TB=TB+rowELEMENTS(7)
				ic=ic+1
				
			Next
			'========================================================================================================
'						ADAUGARE LINIE SUBTOTAL SI TOTAL 
			'========================================================================================================
			headerTabel.SetPosition(350,760)
			headerTabel.SetText("SUBTOTAL")
			headerTabel.DrawOn(PDFPage)
			'	TOTAL NET
			itemLine.SetPosition(400,760)
			itemLine.SetColor(PDFjetConstants1.Color.black)
			itemLine.SetText(NumberFormat2(TN,1,2,2,False))
			itemLine.DrawOn(PDFPage)
			'	TOTAL BRUT
			itemLine.SetPosition(480,760)
			itemLine.SetColor(PDFjetConstants1.Color.black)
			itemLine.SetText(NumberFormat2(TB,1,2,2,False))
			itemLine.DrawOn(PDFPage)
			TG=TG+TB
			curPage=curPage+1
			'========================================================================================================
'						DATE DELEGAT / STAMPILA
			'========================================================================================================
			'line.Initialize(10,650,585,650)
			'line.SetColor(PDFjetConstants1.Color.black)
			'line.SetWidth(1.1)
			'line.DrawOn(PDFPage)
			headerTabel.SetPosition(25,750)
			headerTabel.SetText("Semnatura si")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(20,760)
			headerTabel.SetText("stampila furnizorului")
			headerTabel.DrawOn(PDFPage)
			'Date delegat
			headerTabel.SetPosition(105,750)
			headerTabel.SetText("Date privin Expeditia :")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(105,765)
			headerTabel.SetText("Nume Prenume :")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(105,780)
			headerTabel.SetText("BI/CI :")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(105,795)
			headerTabel.SetText("Mijloc de transport :")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(105,810)
			headerTabel.SetText("Semnatura :")
			headerTabel.DrawOn(PDFPage)
			headerTabel.SetPosition(250,810)
			headerTabel.SetText("Data:")
			headerTabel.DrawOn(PDFPage)
		Next
		headerTabel.SetPosition(350,770)
		headerTabel.SetText("TOTAL")
		headerTabel.DrawOn(PDFPage)
		itemLine.SetPosition(480,770)
		itemLine.SetColor(PDFjetConstants1.Color.black)
		itemLine.SetText(NumberFormat2(TG,1,2,2,False))
		itemLine.DrawOn(PDFPage)
	Next
	PDFjetPDF1.Close
End Sub
'Sub Create_table_report(docName As String,tv As TableView,reportingPeriod As String,title As String)
'	Dim PDFjetPDF1 As PDFjetPDF=CreateBasePDFDocument(title)
'	PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
'	
'	Dim PDFPage As PDFjetPage
'	PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
'
'	Dim PDFFont1 As PDFjetFont
'	PDFFont1.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA_BOLD)
'	PDFFont1.SetSize(7)
'	
'	Dim PDFFont2 As PDFjetFont
'	PDFFont2.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA)
'	PDFFont2.SetSize(7)
'	
'	Dim PDFFont3 As PDFjetFont
'	PDFFont3.Initialize(PDFjetPDF1, PDFjetConstants1.CoreFont.HELVETICA_BOLD_OBLIQUE)
'	PDFFont3.SetSize(7)
'	 
'	Dim line As PDFjetLine
'	line.Initialize(20,20,800,20)
'	line.SetWidth(0.9)
'	line.DrawOn(PDFPage)
'	 
'	Dim PDFTable As PDFjetTable
'	PDFTable.Initialize
'	Dim TableData1 As PDFjetTableData
'	TableData1.Initialize
'	Dim i As Int
'	Dim PDFCell As PDFjetCell
'	Dim hRow As PDFjetCellList
'	Dim Row As PDFjetCellList
'	'itemsList.Initialize
'	'===========================================================
'	'						ADAUG HEADER
'	'===========================================================
'	Dim h(tv.ColumnsCount) As String
'	For c=0 To tv.ColumnsCount-1
'		h(c)=tv.GetColumnHeader(c)
'	Next
'	hRow.Initialize
'	For x=0 To h.Length-1
'		PDFCell.Initialize2(PDFFont1,h(x) )
'		PDFCell.SetBottomPadding(2)
'		PDFCell.SetLeftPadding(2)
'		PDFCell.SetRightPadding(2)
'		PDFCell.SetTopPadding(2)
'		hRow.Add(PDFCell)
'		Log(hRow)
'	Next
'	TableData1.AddRow(hRow)
'	For i=0 To tv.Items.Size-1
'		Row.Initialize
'		Dim rowElementsList() As Object=tv.Items.Get(i)	
'		'rowElementsList=tv.Items.Get(i)
'		For r=0 To rowElementsList.Length-1 			
'			PDFCell.Initialize2(PDFFont2,rowElementsList(r) )
'			PDFCell.SetBottomPadding(2)
'			PDFCell.SetLeftPadding(2)
'			PDFCell.SetRightPadding(2)
'			PDFCell.SetTopPadding(2)
'			Row.Add(PDFCell)
'		Next
'		TableData1.AddRow(Row)
'	Next
'
'	PDFTable.SetData2(TableData1, PDFTable.DATA_HAS_1_HEADER_ROWS)
'	PDFTable.SetCellBordersWidth(0.2)
'	PDFTable.SetPosition(80, 50)
'	PDFTable.SetTextColorInRow(0, PDFjetConstants1.Color.blue)
'	PDFTable.AutoAdjustColumnWidths
''	PDFTable.SetColumnWidth(0, 60)
''	PDFTable.RightAlignNumbers
'	
'	'	here you can see two different ways to render a table that will span more than one page in the PDF document
'	'	comment/uncomment each block of code and you'll see the same results
'	
''	Dim NumberOfPages As Int=PDFTable.GetNumberOfPages(PDFPage)
''	For i=1 To NumberOfPages
''		PDFTable.DrawOn(PDFPage)
''		PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)
''	Next
'	
'	Do While PDFTable.HasMoreData
'		PDFTable.DrawOn(PDFPage)
'		PDFPage.Initialize(PDFjetPDF1, PDFjetConstants1.PageSize.A4_PORTRAIT)

'	Loop
'	
'	
'End Sub

'Sub CopyAssetsToTemp(Filenames() As String)
'	Dim i As Int
'	For i=0 To Filenames.Length-1
'		If Not(File.Exists(File.DirTemp, Filenames(i))) Then
'			File.Copy(File.DirAssets, Filenames(i), File.DirTemp, Filenames(i))
'		End If
'	Next
'End Sub
Sub DeleteTempFiles(Filenames() As String)
	For i=0 To Filenames.Length-1
		File.Delete(File.DirApp, Filenames(i))
	Next
End Sub