﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private CIFlist As MiniSearchView
	Private TxtSocietate As TextField
	Private txtRegComert As TextField
	Private txtAdresa As TextArea
	Private cbCerere As CheckBox
	Private cbDeclaratie As CheckBox
	Private btnGenerare As Button
	Private cbDelegatie As CheckBox
	Private txtAdrDomiciliu As TextArea
	Private txtNumePers As TextField
	Private txtCNP As TextField
	Private btnAnaf As Button
	Private txtSerieCI As TextField
	Private txtFunctia As TextField
	Private txtTel As TextField
	Private txtEmail As TextField
	'Private txtPctLucru As TextField
	Private cbModel As ComboBox
	Private lblTip As Label
	Private lblNrAviz As Label
	Private lblDataAviz As Label
	Private txtSeria As TextField
	Private cbContract As CheckBox
	Private btnTransfer As Button
	Private DPAchizitie As DatePicker
	Private dataAchizitie,dataInstalare As String
	Private tehnician As String
	Private txtNUI As TextField
	Private DPInstalare As DatePicker
	Private cMbTehnician As ChoiceBox
	Private cbDeclaratieInstalare As CheckBox
	Private cbEvidenta As CheckBox
	Private txtValContract As TextField
	Private cbGDPR As CheckBox
	Private txtEliberat As TextField
	Private cbGarantie As CheckBox
	Private tbv As TableView
	Private cbDelegatie2 As CheckBox
	Private txtPctLucru As TextArea
	Private cbPVPredarePrimire As CheckBox
	Private txtNrContract As TextField
	

	Private DPValConANAF As DatePicker
	Private cbTipCon As ComboBox
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	Main.mainTBP.LoadLayout("AddAMEF","Inregistrare AMEF")
	CIFlist.SetItems(dbFunction.get_CIF)
	cbModel.Items.AddAll(dbFunction.get_model_list)
	DateTime.DateFormat="yyyy-MM-dd"
	dataAchizitie=DateTime.Date(DateTime.Now)
	cMbTehnician.Items.AddAll(Array As String("STARINSCHHI ANDREI","NEGRUT RAZVAN-ALIN"))
	cbTipCon.Items.Addall(Array As String("GPRS","LAN"))
	cbTipCon.SelectedIndex=-1
	Log(DateTime.Date(DateTime.Now))
	DPValConANAF.DateTicks=DateTime.Now
	
End Sub

Sub btnAnaf_Click
	Dim dtaNAF As String
	DateTime.DateFormat="yyyy-MM-dd"
	dtaNAF=DateTime.Date(DateTime.Now)
	Submit_Action(CIFlist.TextField.Text,dtaNAF)
End Sub
Sub ShowResult(item As Object)
	Dim resCompany,resDelegat  As ResultSet
	Dim idCompany As String
	Dim m As MSVItemData=item
	resCompany=dbFunction.get_CIF_CompanyDetails(m.Item)
	'incarcare date firma
	Do While resCompany.NextRow
		TxtSocietate.Text=resCompany.GetString("DenumireSocietate")
		txtRegComert.Text=resCompany.GetString("RegComert")
		txtAdresa.Text=resCompany.GetString("AdrSediu")
		idCompany=resCompany.GetString("rowID")
	Loop
	resDelegat=dbFunction.get_datePersFromCompanyID(idCompany)
	' incarcare date delegat
	Do While resDelegat.NextRow
		txtCNP.Text=resDelegat.GetString("CNP")
		txtNumePers.Text=resDelegat.GetString("Nume")
		txtAdrDomiciliu.Text=resDelegat.GetString("Adresa")
		txtSerieCI.Text=resDelegat.GetString("Act_identitate")
		txtEliberat.Text=resDelegat.GetString("eliberatde")
		txtFunctia.Text=resDelegat.GetString("Functia")
		txtTel.Text=resDelegat.GetString("telefon")
		txtEmail.Text=resDelegat.GetString("mail")
	Loop
	'incarcare date puncte de lucru si echipamente
	fill_TV(dbFunction.get_lista_echipementePunctLucru(CIFlist.TextField.Text,""))
	
End Sub
Sub btnGenerare_Click
	Dim idSocietate As String=""
	If validare_CNP(txtCNP.Text) =False Then
		fx.Msgbox(Main.MainForm,"CNP Incorect ! ! !","Eroare introducere date")
		If fx.Msgbox2(Main.MainForm,"CETATEAN STRAIN ? ","EROARE CNP","DA","","NU",fx.MSGBOX_CONFIRMATION)=fx.DialogResponse.NEGATIVE Then
			Return
		End If
	End If
	If txtSeria.Text ="" Then
		fx.Msgbox(Main.MainForm,"Nu ai completat seria Echipamentului ! ! ! ","Eroare introducere date ! ! !")
		Return
	End If
	If cbDeclaratieInstalare.Checked=True Then
		If txtNUI.Text.Length <> 10 Then
			fx.Msgbox(Main.MainForm,"Lungimea N.U.I. este diferita de 10 caractere","Eroare introducere data ")
			Return
		End If
		If  tehnician="" Then
			fx.Msgbox(Main.MainForm,"Nu ai selectat numele tehnicianului","Eroare introducere data ")
			Return
		End If
		If dataInstalare="" Then
			fx.Msgbox(Main.MainForm,"Nu ai selectat data de instalare","Eroare introducere data ")
			Return
		End If
		If fx.Msgbox2(Main.MainForm,"Doresti retiparirea tuturor documentelor ?","Confirmare retiparire","Da","","Nu",fx.MSGBOX_CONFIRMATION)=fx.DialogResponse.NEGATIVE Then
			cbDeclaratie.Checked=False
			cbCerere.Checked=False
			cbDeclaratie.Checked=False
			cbEvidenta.Checked=True
		End If
		If cbContract.Checked=True Then
			If txtNrContract.Text="" Then
				fx.Msgbox(Main.MainForm,"Nu ai completat numarul contractului","Eroare operare")
				Return
			End If
			If txtValContract.Text.Length<3 Or IsNumber(txtValContract.Text)=False Then
				fx.Msgbox(Main.MainForm,"Valoarea contractului este prea mica sau incorecta","Eroare introducere date")
				Return
			End If
		End If
		declaratieInstalare
	End If
	idSocietate=dbFunction.get_company_ID(CIFlist.TextField.Text)
	If dbFunction.get_company_exists(CIFlist.TextField.Text) = "0" Then
		dbFunction.add_company(CIFlist.TextField.Text,TxtSocietate.Text,txtRegComert.Text,txtAdresa.Text)
		'verifica daca exista folderul si creaza folderul pt client
		If File.Exists("C:\My Documents\StartUp\Clienti\"&TxtSocietate.Text,"")=False Then
			If TxtSocietate.Text.EndsWith(" ")=True Then
				TxtSocietate.Text =TxtSocietate.Text.SubString2(0,TxtSocietate.Text.Length-1)
			End If
			File.MakeDir("C:\My Documents\StartUp\Clienti\",TxtSocietate.Text)
			dbFunction.upd_path(CIFlist.TextField.Text,TxtSocietate.Text)
		Else
			If cbCerere.Checked=True And cbDeclaratie.Checked=True And cbDeclaratieInstalare.Checked=False And cbContract.Checked=False And cbEvidenta.Checked=False Then
				fx.Msgbox(Main.MainForm,"Exista deja folder cu aceasta denumire ","Mesaj sistem")
				Return
			End If
		End If
			
	End If
	idSocietate=dbFunction.get_company_ID(CIFlist.TextField.Text)
	'Verificare existenta afresa pct lucru in baza ID societate
	If dbFunction.get_AdrFilialaExist(txtPctLucru.Text,idSocietate)=0 Then
		dbFunction.add_Filiala(idSocietate,txtPctLucru.Text)
	End If

	If dbFunction.get_datePers_exists(txtCNP.Text,idSocietate)=0 Then
		dbFunction.add_date_pers(idSocietate,txtCNP.Text,txtNumePers.Text,txtAdrDomiciliu.Text,txtSerieCI.Text,txtEliberat.Text,txtFunctia.Text,txtTel.Text,txtEmail.Text)
	End If
	If dbFunction.get_echipament_exist(txtSeria.Text)=0 Then
		If dataInstalare="" Or dataInstalare=Null Then
			dataInstalare="1900-01-01"
		End If
		dbFunction.add_echipament(dbFunction.get_idFiliala_from_adress(txtPctLucru.Text,idSocietate),txtSeria.Text,lblTip.Text,cbModel.Value,"Inchisa",lblNrAviz.Text,lblDataAviz.Text,txtNUI.Text,dataAchizitie,dataInstalare,"0")
		'dbFunction.add_echipament(dbFunction.get_idFiliala_from_adress(txtPctLucru.Text,idSocietate),txtSeria.Text,lblTip.Text,cbModel.Value,"Inchisa",lblNrAviz.Text,lblDataAviz.Text,txtNUI.Text,dataAchizitie,dataInstalare,"0")
	Else
		dbFunction.update_echipament(txtNUI.Text,dataInstalare,dbFunction.get_idLinie_from_echipamente(txtSeria.Text,dbFunction.get_idFiliala_from_adress(txtPctLucru.Text,idSocietate),dataAchizitie,"0"))
'		' = = = = =  = = = = = = = == =  ADAUGARE CONTRAC = = = = = = = = = =  = = = = = =
'		Dim contractperdata() As String
'		Dim nrcontract As String
'		Dim dtcontract As String
'		contractperdata=Regex.Split("/",txtNrContract.Text)
'		nrcontract=contractperdata(0)
'		dtcontract=contractperdata(1)
'	DateTime.DateFormat="yyyy-MM-dd"
'		dbFunction.add_contract(idSocietate,nrcontract,dtcontract,DateTime.Add( DateTime.DateParse(dtcontract),1,0,0),"contract",txtValContract.Text,"Valabil")
'		Dim rs As ResultSet=dbFunction.get_contract(txtNrContract.Text)
'		rs.NextRow
'		dbFunction.add_anexa(rs.GetString("rowID"),rs.GetString("NrContract"),dtcontract,DateTime.Add( DateTime.DateParse(dtcontract),1,0,0), txtValContract.Text)
'		Dim rsdc As ResultSet=dbFunction.get_detalii_anexa(nrcontract,"")
'		rsdc.NextRow
'		dbFunction.add_detalii_contract(rsdc.GetString("rowID"),m.Get("idSocietate"),m.Get("idFiliala"),m.Get("idEchipamente"),nrcontract,"Anexa")
'		'= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
	End If
	If cbTipCon.SelectedIndex<>-1 Then
		If cbTipCon.Value="GPRS" Then
			dbFunction.update_conexiune_anaf( cbTipCon.Value,DateUtils.TicksToString( DPValConANAF.DateTicks),txtSeria.Text)
		Else
			dbFunction.update_conexiune_anaf( cbTipCon.Value,"2100-01-01",txtSeria.Text)
		End If
	End If
	If cbDeclaratie.Checked=True Then createDeclaratie
	If cbDelegatie.Checked=True Then createDelegatie
	If cbCerere.Checked=True Then createCerere
	If cbContract.Checked=True Then createContract
	If cbEvidenta.Checked=True Then create_luareInEvidenta
	If cbGDPR.Checked=True Then create_gdpr
	If cbGarantie.Checked=True Then create_cert_garantie
	If cbDelegatie2.Checked=True Then createDelegatie2
	If cbPVPredarePrimire.Checked=True Then create_PVPredarePrimire
	Dim fileLIst As List=File.ListFiles(File.DirApp&"\TMP")
	For i=0 To fileLIst.Size-1
		Log(fileLIst.get(i))
		Log("C:\My Documents\StartUp\Clienti\"&TxtSocietate.Text)
		File.Copy(File.DirApp&"\TMP",fileLIst.get(i),"C:\My Documents\StartUp\Clienti\"&TxtSocietate.Text,fileLIst.get(i))
		Sleep(1000)
		File.Delete(File.DirApp&"\TMP",fileLIst.get(i))
		fx.ShowExternalDocument(File.GetUri("C:\My Documents\StartUp\Clienti\"&TxtSocietate.Text,fileLIst.get(i)))
	Next
	
	clearFields
End Sub
Sub clearFields
	CIFlist.TextField.Text=""
	TxtSocietate.Text=""
	txtRegComert.Text=""
	txtAdresa.Text=""
	txtPctLucru.Text=""
	txtCNP.Text=""
	txtNumePers.Text=""
	txtAdrDomiciliu.Text=""
	txtSerieCI.Text=""
	txtEliberat.Text=""
	txtTel.Text=""
	txtEmail.Text=""
	txtSeria.Text=""
	txtNUI.Text=""
	txtValContract.Text=""
	cMbTehnician.SelectedIndex=-1
	cbModel.SelectedIndex=-1
	tbv.Items.Clear
	dataInstalare=""
	dataAchizitie=""
	cbTipCon.SelectedIndex=-1
	DPValConANAF.DateTicks=0
DPInstalare.DateTicks=0
DPAchizitie.DateTicks=0
End Sub
Public Sub LoadCustomerData(cui As String)
	
End Sub
Sub fill_TV(resdate As ResultSet)
	tbv.Items.Clear
	tbv.SetColumns(Array As String("Serie","NUI","Model","Adresa Instalare","Data Instalare","Data Achizitie"))
	Do While resdate.NextRow
		Dim row(6) As Object
		If resdate.GetString("Seria")<>Null Then 
			row(0)=resdate.GetString("Seria")
		End If
		If resdate.GetString("NUI")<>Null Then 
			row(1)=resdate.GetString("NUI")
		End If
		If resdate.GetString("Model")<>Null Then 
			row(2)=resdate.GetString("Model")
		End If
		If resdate.GetString("AdresaFiliala")<>Null Then 
			row(3)=resdate.GetString("AdresaFiliala")
		End If
		If resdate.GetString("dataInstalare")<>Null Then 
			row(4)=resdate.GetString("dataInstalare")
		End If
		If resdate.GetString("dataVanzare")<> Null Then 
			row(5)=resdate.GetString("dataVanzare")
		End If
		tbv.Items.Add(row)
	Loop
End Sub
Sub createCerere
	Dim fileName As String = File.DirApp&"\Template\cerere_atribuire.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"TMP")=False Then
		File.MakeDir(File.DirApp,"TMP")
		File.Copy(File.DirApp,"cerere_atribuire.xlsx",File.DirApp&"\TMP",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","cerere_atribuire.xlsx",File.DirApp&"\TMP","cerere_atribuire.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","cerere_atribuire.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)
	sheet.GetRow(6).GetCell(2).ValueString=CIFlist.TextField.Text
	sheet.GetRow(7).GetCell(2).ValueString=TxtSocietate.Text
	sheet.GetRow(8).GetCell(2).ValueString=txtAdresa.Text
	sheet.GetRow(11).GetCell(2).ValueString=txtCNP.Text
	sheet.GetRow(12).GetCell(2).ValueString=txtNumePers.Text
	sheet.GetRow(13).GetCell(2).ValueString=txtAdrDomiciliu.Text
	sheet.GetRow(14).GetCell(2).ValueString=txtSerieCI.Text &" "&txtEliberat.Text
	sheet.GetRow(15).GetCell(2).ValueString=txtFunctia.Text
	sheet.GetRow(20).GetCell(1).ValueString=lblTip.Text
	sheet.GetRow(20).GetCell(2).ValueString=cbModel.Value
	sheet.GetRow(20).GetCell(3).ValueString="Inchisa"
	sheet.GetRow(20).GetCell(4).ValueString=txtSeria.Text
	sheet.GetRow(20).GetCell(5).ValueString=lblNrAviz.Text
	sheet.GetRow(20).GetCell(6).ValueString=lblDataAviz.Text
	sheet.GetRow(33).GetCell(0).ValueString=txtNumePers.Text
	wbRep.Save(File.DirApp&"\TMP","cerere_atribuire.xlsx")
	wbRep.Close
End Sub
Sub createDeclaratie
	Dim fileName As String = File.DirApp&"\Template\Declaratie.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"TMP")=False Then
		File.MakeDir(File.DirApp,"TMP")
		File.Copy(File.DirApp,"Declaratie.xlsx",File.DirApp&"\TMP",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","Declaratie.xlsx",File.DirApp&"\TMP","Declaratie.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","Declaratie.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)
	sheet.GetRow(3).GetCell(2).ValueString=CIFlist.TextField.Text
	sheet.GetRow(4).GetCell(2).ValueString=TxtSocietate.Text
	sheet.GetRow(5).GetCell(2).ValueString=txtAdresa.Text
	sheet.GetRow(8).GetCell(2).ValueString=txtCNP.Text
	sheet.GetRow(9).GetCell(2).ValueString=txtNumePers.Text
	sheet.GetRow(10).GetCell(2).ValueString=txtAdrDomiciliu.Text
	sheet.GetRow(11).GetCell(2).ValueString=txtSerieCI.Text&" "&txtEliberat.Text
	sheet.GetRow(12).GetCell(2).ValueString=txtFunctia.Text
	sheet.GetRow(14).GetCell(0).ValueString=$""In calitate de Administrator cunoscand prevederile codului penal, declar pe propria raspundere ca aparatul de marcat electronic fiscal, achizitional la ${dataAchizitie} in numar de 1 avand elementele de identificare prezentate in sectiunea III vor fi instalate conform detaliilor de mai jos. "$
	sheet.GetRow(21).GetCell(1).ValueString=lblTip.Text
	sheet.GetRow(21).GetCell(2).ValueString=cbModel.Value
	sheet.GetRow(21).GetCell(3).ValueString="Inchisa"
	sheet.GetRow(21).GetCell(4).ValueString=txtSeria.Text
	sheet.GetRow(21).GetCell(5).ValueString=lblNrAviz.Text
	sheet.GetRow(21).GetCell(6).ValueString=lblDataAviz.Text
	sheet.GetRow(21).GetCell(8).ValueString=txtPctLucru.Text
	sheet.GetRow(25).GetCell(0).ValueString="Nr.Tel : "&txtTel.Text
	sheet.GetRow(34).GetCell(0).ValueString=txtNumePers.Text
	wbRep.Save(File.DirApp&"\TMP","Declaratie.xlsx")
	wbRep.Close
End Sub
Sub createDelegatie
	Dim fileName As String = File.DirApp&"\Template\Imputernicire.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"TMP")=False Then
		File.MakeDir(File.DirApp,"TMP")
		File.Copy(File.DirApp,"Imputernicire.xlsx",File.DirApp&"\TMP",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","Imputernicire.xlsx",File.DirApp&"\TMP","Imputernicire.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","Imputernicire.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)	
	sheet.GetRow(1).GetCell(2).ValueString=txtRegComert.Text
	sheet.GetRow(2).GetCell(2).ValueString=CIFlist.TextField.Text
	sheet.GetRow(6).GetCell(0).ValueString=$"Subsemnatul ${txtNumePers.Text}, domiciliat in ${txtAdrDomiciliu.Text}, posesor al B.I./C.I. seria si nr. ${txtSerieCI.Text}, reprezentant legal al societatii ${TxtSocietate.Text}, Cu sediul social in ${txtAdresa.Text}, Cod  Fiscal ${CIFlist.TextField.Text}, telefon ${txtTel.Text},imputernicesc pe tehnicianul autorizat pentru service STARINSCHI ANDREI al unitalii de service autorizata SMART CAS TECH S.R.L., identificat cu legitimatia 01 si sigiliul SH050, sã depuna  la AJFP  Bihor documentaliile necesare  oNinerii Certificatului de atribuire a numarului unic de indentificare Si sa ridice de la AJFP Bihor documentul emis cu denumirea, Certificat de atribuire N.U.I., emis pentru A.M.E.F. tipul ${lblTip.Text},  model ${cbModel.Value},denumirea comerciala ${cbModel.Value}, seria aparatului ${txtSeria.Text}, in vederea punerii in functiune §i fiscalizare."$
	sheet.GetRow(32).GetCell(0).ValueString=DateTime.Date(DateTime.Now)
	wbRep.Save(File.DirApp&"\TMP","Imputernicire.xlsx")
	wbRep.Close
End Sub
Sub createDelegatie2
	Dim fileName As String = File.DirApp&"\Template\Imputernicire2.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"TMP")=False Then
		File.MakeDir(File.DirApp,"Temp")
		File.Copy(File.DirApp,"Imputernicire2.xlsx",File.DirApp&"\TMP",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","Imputernicire2.xlsx",File.DirApp&"\TMP","Imputernicire2.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","Imputernicire2.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)	
	sheet.GetRow(1).GetCell(2).ValueString=txtRegComert.Text
	sheet.GetRow(2).GetCell(2).ValueString=CIFlist.TextField.Text
	sheet.GetRow(6).GetCell(0).ValueString=$"Subsemnatul ${txtNumePers.Text}, domiciliat in ${txtAdrDomiciliu.Text}, posesor al B.I./C.I. seria si nr. ${txtSerieCI.Text}, reprezentant legal al societatii ${TxtSocietate.Text}, Cu sediul social in ${txtAdresa.Text}, Cod  Fiscal ${CIFlist.TextField.Text}, telefon ${txtTel.Text},imputernicesc pe tehnicianul autorizat pentru service STARINSCHI ANDREI al unitalii de service autorizata SMART CAS TECH S.R.L., identificat cu legitimatia 01 si sigiliul SH050, sã depuna si sa ridice de la AJFP  Bihor cartea de interventii,registrul speciale si declaratiile de instalare emise pentru A.M.E.F tipul ${lblTip.Text},  model ${cbModel.Value},denumirea comerciala ${cbModel.Value}, seria aparatului ${txtSeria.Text}."$
	sheet.GetRow(32).GetCell(0).ValueString=DateTime.Date(DateTime.Now)
	wbRep.Save(File.DirApp&"\TMP","Imputernicire2.xlsx")
	wbRep.Close
End Sub
Sub createContract
	Dim fileName As String = File.DirApp&"\Template\Contract de revizie anuala.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"TMP")=False Then
		File.MakeDir(File.DirApp,"Temp")
		File.Copy(File.DirApp,"Contract de revizie anuala.xlsx",File.DirApp&"\Temp",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","Contract de revizie anuala.xlsx",File.DirApp&"\TMP","Contract de revizie anuala.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","Contract de revizie anuala.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)
	DateTime.DateFormat="dd.MM.yyyy"
	sheet.GetRow(2).GetCell(2).ValueString=CIFlist.TextField.Text
	sheet.GetRow(1).GetCell(2).ValueString=txtRegComert.Text
	sheet.GetRow(3).GetCell(0).ValueString=txtNrContract.Text
	sheet.GetRow(14).GetCell(0).ValueString=TxtSocietate.Text
	sheet.GetRow(15).GetCell(2).ValueString=txtAdresa.Text
	sheet.GetRow(16).GetCell(2).ValueString=txtTel.Text
	sheet.GetRow(17).GetCell(2).ValueString=txtEmail.Text
	sheet.GetRow(18).GetCell(4).ValueString=txtRegComert.Text
	sheet.GetRow(19).GetCell(2).ValueString=CIFlist.TextField.Text
	sheet.GetRow(136).GetCell(2).ValueString=DateTime.Date(DateTime.Now)
	sheet.GetRow(137).GetCell(5).ValueString=TxtSocietate.Text
	sheet.GetRow(155).GetCell(0).ValueString=TxtSocietate.Text
	sheet.GetRow(156).GetCell(2).ValueString=txtAdresa.Text
	sheet.GetRow(157).GetCell(2).ValueString=txtTel.Text
	sheet.GetRow(158).GetCell(2).ValueString=txtEmail.Text
	sheet.GetRow(159).GetCell(4).ValueString=txtRegComert.Text
	sheet.GetRow(160).GetCell(2).ValueString=CIFlist.TextField.Text
	sheet.GetRow(205).GetCell(5).ValueString=TxtSocietate.Text
	sheet.GetRow(235).GetCell(1).ValueString=DateTime.Date(DateTime.Now)
	sheet.GetRow(235).GetCell(8).ValueString=txtNrContract.Text
	sheet.GetRow(241).GetCell(3).ValueString=TxtSocietate.Text
	sheet.GetRow(242).GetCell(3).ValueString=CIFlist.TextField.Text
	sheet.GetRow(246).GetCell(3).ValueString=DateTime.Date(DateTime.Now)
	sheet.GetRow(250).GetCell(0).ValueString=cbModel.Value
	sheet.GetRow(250).GetCell(3).ValueString=txtSeria.Text
	sheet.GetRow(250).GetCell(5).ValueString=txtPctLucru.Text
	sheet.GetRow(250).GetCell(8).ValueString=txtValContract.Text
	wbRep.Save(File.DirApp&"\TMP","Contract de revizie anuala.xlsx")
	wbRep.Close
End Sub
Sub declaratieInstalare
	Dim fileName As String = File.DirApp&"\Template\Declaratie de instalare.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"Temp")=False Then
		File.MakeDir(File.DirApp,"Temp")
		File.Copy(File.DirApp,"Declaratie de instalare.xlsx",File.DirApp&"\Temp",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","Declaratie de instalare.xlsx",File.DirApp&"\TMP","Declaratie de instalare.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","Declaratie de instalare.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)
	sheet.GetRow(7).GetCell(2).ValueString=txtNumePers.Text
	sheet.GetRow(8).GetCell(2).ValueString=txtCNP.Text
	sheet.GetRow(9).GetCell(2).ValueString=txtAdrDomiciliu.Text
	sheet.GetRow(10).GetCell(2).ValueString=txtSerieCI.Text&" "&txtEliberat.Text
	sheet.GetRow(11).GetCell(2).ValueString=txtTel.Text
	sheet.GetRow(12).GetCell(2).ValueString=txtFunctia.Text
	sheet.GetRow(14).GetCell(2).ValueString=CIFlist.TextField.Text
	sheet.GetRow(15).GetCell(2).ValueString=TxtSocietate.Text
	sheet.GetRow(16).GetCell(2).ValueString=txtAdresa.Text
	sheet.GetRow(17).GetCell(3).ValueString=dataInstalare
	sheet.GetRow(18).GetCell(0).ValueString=txtPctLucru.Text
	sheet.GetRow(20).GetCell(1).ValueString=lblTip.Text
	sheet.GetRow(20).GetCell(5).ValueString=cbModel.Value
	sheet.GetRow(21).GetCell(4).ValueString=txtSeria.Text
	sheet.GetRow(22).GetCell(6).ValueString=lblNrAviz.Text&"/"&lblDataAviz.Text
	sheet.GetRow(23).GetCell(2).ValueString=txtNUI.Text
	sheet.GetRow(23).GetCell(7).ValueString=dataAchizitie
	wbRep.Save(File.DirApp&"\TMP","Declaratie de instalare.xlsx")
	wbRep.Close
End Sub
Sub create_luareInEvidenta
	Dim fileName As String = File.DirApp&"\Template\Luare in evidenta.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"Temp")=False Then
		File.MakeDir(File.DirApp,"Temp")
		File.Copy(File.DirApp,"Luare in evidenta.xlsx",File.DirApp&"\Temp",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","Luare in evidenta.xlsx",File.DirApp&"\TMP","Luare in evidenta.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","Luare in evidenta.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)
	sheet.GetRow(4).GetCell(2).ValueString=TxtSocietate.Text
	sheet.GetRow(5).GetCell(2).ValueString=CIFlist.TextField.Text
	sheet.GetRow(6).GetCell(2).ValueString=txtAdresa.Text
	sheet.GetRow(8).GetCell(2).ValueString=txtNumePers.Text
	sheet.GetRow(9).GetCell(5).ValueString=txtSerieCI.Text&" "&txtEliberat.Text
	sheet.GetRow(11).GetCell(0).ValueString=txtPctLucru.Text
	sheet.GetRow(23).GetCell(1).ValueString=txtTel.Text
	sheet.GetRow(25).GetCell(5).ValueString=TxtSocietate.Text

	wbRep.Save(File.DirApp&"\TMP","Luare in evidenta.xlsx")
	wbRep.Close
End Sub
Sub create_gdpr
	Dim fileName As String = File.DirApp&"\Template\GDPR.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"TMP")=False Then
		File.MakeDir(File.DirApp,"TMP")
		File.Copy(File.DirApp,"GDPR.xlsx",File.DirApp&"\TMP",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","GDPR.xlsx",File.DirApp&"\TMP","GDPR.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","GDPR.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)
	sheet.GetRow(9).GetCell(3).ValueString=txtNumePers.text	
	sheet.GetRow(24).GetCell(0).ValueString=txtNumePers.text
	sheet.GetRow(24).GetCell(5).ValueString=DateTime.Date(DateTime.Now)
	
	wbRep.Save(File.DirApp&"\TMP","GDPR.xlsx")
	wbRep.Close
End Sub
Sub create_cert_garantie
	Dim fileName As String = File.DirApp&"\Template\certificat garantie.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"TMP")=False Then
		File.MakeDir(File.DirApp,"TMP")
		File.Copy(File.DirApp,"certificat garantie.xlsx",File.DirApp&"\TMP",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","certificat garantie.xlsx",File.DirApp&"\TMP","certificat garantie.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","certificat garantie.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)
	sheet.GetRow(2).GetCell(0).ValueString="TIP : "&lblTip.Text&","
	sheet.GetRow(2).GetCell(2).ValueString="MODEL :"&cbModel.Value
	sheet.GetRow(3).GetCell(2).ValueString=txtSeria.Text
	sheet.GetRow(7).GetCell(3).ValueString=TxtSocietate.Text
	sheet.GetRow(9).GetCell(3).ValueString=txtTel.Text
	sheet.GetRow(11).GetCell(3).ValueString=txtEmail.Text
	wbRep.Save(File.DirApp&"\TMP","certificat garantie.xlsx")
	wbRep.Close
End Sub
Sub create_PVPredarePrimire
	Dim fileName As String = File.DirApp&"\Template\PVPredarePrimire.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"TMP")=False Then
		File.MakeDir(File.DirApp,"TMP")
		File.Copy(File.DirApp,"PVPredarePrimire.xlsx",File.DirApp&"\TMP",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","PVPredarePrimire.xlsx",File.DirApp&"\TMP","PVPredarePrimire.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","PVPredarePrimire.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)
	sheet.GetRow(9).GetCell(2).ValueString=TxtSocietate.Text
	sheet.GetRow(8).GetCell(2).ValueString=CIFlist.TextField.Text
	sheet.GetRow(10).GetCell(2).ValueString=txtAdresa.Text
	sheet.GetRow(15).GetCell(6).ValueString=cbModel.Value
	sheet.GetRow(16).GetCell(1).ValueString=txtSeria.Text
	sheet.GetRow(16).GetCell(5).ValueString=txtNUI.Text
	
	wbRep.Save(File.DirApp&"\TMP","PVPredarePrimire.xlsx")
	wbRep.Close
End Sub
Sub cbModel_ValueChanged (Value As Object)
	If cbModel.SelectedIndex<>-1 Then
		Dim cur As ResultSet
		cur =dbFunction.get_ecr_detail(Value)
		cur.NextRow
		lblTip.Text=cur.GetString("Tip")
		lblNrAviz.Text=cur.GetString("NrAviz")
		lblDataAviz.Text=cur.GetString("DataAviz")
	Else
		lblTip.Text=""
		lblNrAviz.Text=""
		lblDataAviz.Text=""
	End If
End Sub
Sub Submit_Action(CUI As String,DATA As String)
	Dim j As HttpJob
	j.Initialize("",Me )
	Log($"[{"cui": ${CUI},"data": "${DATA}"}]"$)
	'03.05.2021
	j.PostString("https://webservicesp.anaf.ro/PlatitorTvaRest/api/v5/ws/tva",$"[{"cui": ${CUI},"data": "${DATA}"}]"$)
	'j.PostString("https://webservicesp.anaf.ro/PlatitorTvaRest/api/v4/ws/tva",$"[{"cui": ${CUI},"data": "${DATA}"}]"$)
	j.GetRequest.SetContentType("application/json")
	Wait For(j) JobDone(j As HttpJob)
	If j.Success Then
		Log(j.GetString)
		Dim parser As JSONParser
		parser.Initialize(j.GetString)
		Dim root As Map = parser.NextObject
		Dim found As List = root.Get("found")
		For Each colfound As Map In found
			Dim dataPublicare As String = colfound.Get("dataPublicare")
			Log(dataPublicare)
			Dim DATA As String = colfound.Get("data")
			Dim mesaj_ScpTVA As String = colfound.Get("mesaj_ScpTVA")
			If mesaj_ScpTVA="platitor IN SCOPURI de TVA la data cautata" Then
				CIFlist.TextField.Text="RO"&colfound.Get("cui")
				'customerData.Put("cui","RO"&colfound.Get("cui"))
			Else
				CIFlist.TextField.text=colfound.Get("cui")
				'customerData.Put("cui",colfound.Get("cui"))
			End If
			Dim dataSfarsitTvaInc As String = colfound.Get("dataSfarsitTvaInc")
			Dim tipActTvaInc As String = colfound.Get("tipActTvaInc")
			Dim dataRadiere As String = colfound.Get("dataRadiere")
			Dim data_inceput_ScpTVA As String = colfound.Get("data_inceput_ScpTVA")
			Dim dataReactivare As String = colfound.Get("dataReactivare")
			Dim statusInactivi As String = colfound.Get("statusInactivi")
			If statusInactivi="true" Then
				fx.Msgbox(Main.MainForm,"FIRMA INACTIVA","ALERTA")
			End If
			Dim statusSplitTVA As String = colfound.Get("statusSplitTVA")
			Dim denumire As String = colfound.Get("denumire")
			TxtSocietate.Text=denumire
			'customerData.Put("Beneficiar",denumire)
			Dim data_sfarsit_ScpTVA As String = colfound.Get("data_sfarsit_ScpTVA")
			Dim dataInceputSplitTVA As String = colfound.Get("dataInceputSplitTVA")
			'Dim CUI As Int = colfound.Get("cui")
			'Log(CUI)
			Dim dataInactivare As String = colfound.Get("dataInactivare")
			'Dim adresa() As String = Regex.Split(",", colfound.Get("adresa"))
			txtAdresa.Text=colfound.Get("adresa")
			'txtJudet.Text=adresa(0)
			'customerData.Put("judet",adresa(0))
			'txtLocalitate.Text=adresa(1)
			'customerData.Put("localitate",adresa(1))
'			For i=2 To adresa.Length-1
'				txtStr.Text=txtStr.Text & adresa(i)&","
'				'txtStr.Text=$"${adresa(2)},${adresa(3)}"$
'			Next
			'customerData.Put("str",txtStr.Text)
			'Log(adresa)
			Dim data_anul_imp_ScpTVA As String = colfound.Get("data_anul_imp_ScpTVA")
			Dim statusTvaIncasare As String = colfound.Get("statusTvaIncasare")
			Dim scpTVA As String = colfound.Get("scpTVA")
			Dim dataActualizareTvaInc As String = colfound.Get("dataActualizareTvaInc")
			Dim dataPublicareTvaInc As String = colfound.Get("dataPublicareTvaInc")
			Dim dataInceputTvaInc As String = colfound.Get("dataInceputTvaInc")
		Next
		Dim notfound As List = root.Get("notfound")
		Dim cod As Int = root.Get("cod")
		Dim message As String = root.Get("message")
	
	Else
		Log(j.ErrorMessage)
		fx.Msgbox(Main.MainForm,j.ErrorMessage &CRLF& message,"Eroare interogare server M.Finante")
	End If
	j.Release
End Sub

Sub btnTransfer_Click
	txtPctLucru.Text= txtAdresa.Text 
End Sub

Sub DPAchizitie_ValueChanged (Value As Long)
	DateTime.DateFormat="yyyy-MM-dd"
	dataAchizitie=DateTime.Date(Value)
	Log(dataAchizitie)
End Sub

Sub DPInstalare_ValueChanged (Value As Long)
	DateTime.DateFormat="yyyy-MM-dd"
	dataInstalare=DateTime.Date(Value)
End Sub

Sub cMbTehnician_SelectedIndexChanged(Index As Int, Value As Object)
	tehnician=Value
End Sub

Sub cbGDPR_CheckedChange(Checked As Boolean)
	
End Sub

Sub tbv_SelectedRowChanged(Index As Int, Row() As Object)
	If Index <>-1 Then
	Log(Index)
	cbModel.Value=Row(2)
	txtSeria.Text=Row(0)
	txtNUI.Text=Row(1)
	txtPctLucru.Text=Row(3)
	Log(Row(4))
	DateTime.DateFormat="yyyy-MM-dd"
	DPInstalare.DateTicks=DateTime.DateParse(Row(4)) 'dbFunction.DateFormat2( Row(4))
		DPAchizitie.DateTicks=DateTime.DateParse(Row(5)) 'dbFunction.DateFormat2( Row(5))
	
End If 

End Sub
Sub validare_CNP(cnp As String) As Boolean
	Dim  cheie() As String= Array As String (2,7,9,1,4,6,3,5,8,2,7,9)
	If cnp.Length<> 13 Then Return False
	Dim suma As Int=0
	Dim cc As Int
	For i=0 To cnp.Length-2 
		
		suma =suma + cnp.SubString2(i,i+1) *cheie(i)
		Log(suma)
	Next
	Log(suma Mod 11)
	Log(cnp.SubString2(cnp.Length-2,cnp.Length-1))
	cc=(suma Mod 11)
	If cc=10 And cnp.SubString2(cnp.Length-1,cnp.Length)=1 Then Return True
	If cc=cnp.SubString2(cnp.Length-1,cnp.Length) Then 
		Return True
	Else 
		Return False
			
	End If
End Sub



Private Sub DPValConANAF_ValueChanged (Value As Long)
	
End Sub

Private Sub cbTipCon_SelectedIndexChanged(Index As Int, Value As Object)
	
End Sub