﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private lblDenSoc As Label
	Private lblAdrInstalare As Label
	Private txtSolicitare As TextArea
	Private txtRezolvare As TextArea
	Private btnOK As Button
	Private btnAdd As Button
	Private tbl As TableView
	Private sv As SearchView
	Private dpDataInterventie As DatePicker
	Private chkSelectAll As CheckBox
	Dim NrBifate As Int=0
	Private cmbtehnician As ComboBox
	Private cbExternalCustomer As CheckBox
	Private CMBActivitate As ComboBox
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	Main.mainTBP.LoadLayout("Fisa_service","Fisa Service")
	sv.SetItems(dbFunction.get_companyNameList)
	DateTime.DateFormat="dd-MM-yyyy"
	dpDataInterventie.DateFormat="dd-MM-yyyy"
	cmbtehnician.Items.AddAll(dbFunction.get_lista_tehnicieni)
	CMBActivitate.Items.AddAll(Array As String("FISCALIZARE","FISCALIZARE + CONECTARE ANAF","CONECTARE ANAF","INSPECTIE TEHNICA ANUALA","MODIFICARE PUNCT DE LUCRU","DEFISCALIZARE"))
End Sub

Sub sv_ItemClick (Value As String)
	Dim rs As ResultSet=dbFunction.get_details_from_companyName(Value)
	rs.NextRow
	lblDenSoc.Text=rs.GetString("DenumireSocietate")
	' IDSOCIETATE - IN TAG LABEL
	lblDenSoc.Tag=rs.GetString("rowID")
	fill_table(dbFunction.get_lista_echipementePunctLucru(rs.GetString("CIF"),""))
End Sub

Sub fill_table (rs As ResultSet)
	tbl.Items.Clear
	tbl.SetColumns(Array As String("Selectare","Serie Echipament","NUI","Adresa Instalare","Data Instalare"))
	Do While rs.NextRow
'		
		Dim row(5) As Object
		Dim chk As CheckBox
	Dim m As Map
	m.Initialize
		chk.Initialize("ChkSerie")
		m.Put("seria", rs.GetString("Seria"))
		m.Put("idEchipament",rs.GetString("idEchipament"))
	
		chk.Tag= m
		row(0)=chk
		If rs.GetString("Seria")<>Null Then
			row(1)=rs.GetString("Seria")
			
		End If
		If rs.GetString("NUI")<>Null Then
			row(2)=rs.GetString("NUI")
		End If
		If rs.GetString("AdresaFiliala")<>Null Then
			row(3)=rs.GetString("AdresaFiliala")
		End If
		If rs.GetString("dataInstalare")<>Null Then
			row(4)=rs.GetString("dataInstalare")
		End If
		
		tbl.Items.Add(row)
	Loop
End Sub

Sub tbl_SelectedRowChanged(Index As Int, Row() As Object)
	
End Sub

Sub btnAdd_Click
	'Log( DateTime.Date( dpDataInterventie.DateTicks))
	For Each row() As Object In tbl.Items
		
		
	Next
End Sub


Sub btnOK_Click
	If lblDenSoc.Tag=Null Then 
		fx.Msgbox(Main.MainForm,"NU AI SELECTAT NICI O SOCIETATEA","EROARE OPERARE")
		Return
	End If
	If cmbtehnician.SelectedIndex=-1 Then 
		fx.Msgbox(Main.MainForm,"Nu ai selectat numele tehnicianului ! ! ! ","Eroare Operare")
		Return
	End If
	Dim idfisa As Int=0
	DateTime.DateFormat="yyyy-MM-dd"
	
	dbFunction.add_continut_fisa_service(lblDenSoc.Tag,txtSolicitare.Text,txtRezolvare.Text,DateTime.Date(dpDataInterventie.DateTicks),cmbtehnician.Value)
	idfisa=dbFunction.get_id_fisa_service(DateTime.Date(dpDataInterventie.DateTicks),txtSolicitare.Text,txtRezolvare.Text,lblDenSoc.Tag)
	For Each row() As Object In tbl.Items
		Dim chk As CheckBox=row(0)
		
		If chk.Checked=True Then
			Dim mp As Map=chk.Tag
			dbFunction.add_fisa_service_detalii(mp.Get("seria"),idfisa,mp.Get("idEchipament"))
'		Else 
'			dbFunction.add_fisa_service_detalii(mp.Get("seria"),idfisa,mp.Get("idEchipament"))
		End If
	Next
	Dim adresainterventie As String
	Dim rs As ResultSet = dbFunction.get_fisa_service_from_id(idfisa)
	Do While rs.NextRow
		adresainterventie=rs.GetString("AdresaFiliala")
	Loop
	create_Fisa_service(DateTime.Date(dpDataInterventie.DateTicks),adresainterventie)
	COPIERE_FISIER(lblDenSoc.Text,DateTime.Date(dpDataInterventie.DateTicks))
	txtRezolvare.Text=""
	txtSolicitare.Text=""
	lblDenSoc.Text=""
	lblDenSoc.Tag=""
	chkSelectAll.Checked=False
	tbl.Items.Clear
cbExternalCustomer.Checked=False
CMBActivitate.SelectedIndex=-1

End Sub

Sub ChkSerie_CheckedChange(Checked As Boolean)
	Dim chk As CheckBox
	
	chk=Sender
	
	Dim m As Map=chk.Tag

	If chk.Checked=True Then
		txtSolicitare.Text= txtSolicitare.Text & m.Get("seria") & CRLF
		txtRezolvare.Text= txtRezolvare.Text & m.Get("seria") & CRLF

	Else
		Dim x As String=m.Get("seria")
		Dim tr As String=txtRezolvare.Text
		Dim ts As String=txtSolicitare.Text
		txtRezolvare.Text=Regex.Replace(m.Get("seria")&CRLF,tr,"")
		txtSolicitare.Text=Regex.Replace(m.Get("seria")&CRLF,ts,"")
	
	End If

'For Each row() As Object In tbl.Items
'	 Dim bifa As CheckBox=row(0)
'	 If bifa.Checked=True Then 
'	 	NrBifate=NrBifate+1
'	Else 
'		NrBifate=NrBifate-1	
'	End If
'Next
'Log(NrBifate)
'If NrBifate=tbl.Items.Size-1 Then chkSelectAll.Checked=True
'
'If NrBifate=0 Then chkSelectAll.Checked=False
End Sub

Sub chkSelectAll_CheckedChange(Checked As Boolean)
	If Checked=True Then
		For Each row() As Object In tbl.Items
			Dim chk As CheckBox=row(0)
			chk.Checked=True
		Next
	Else
		For Each row() As Object In tbl.Items
			Dim chk As CheckBox=row(0)
			chk.Checked=False
		Next
	End If
End Sub
Sub create_Fisa_service(DATAFS As String,adresa As String)
	Dim fileName As String = File.DirApp&"\Template\fisa service 2020.xlsx"
	Dim wbRep As PoiWorkbook
	If File.IsDirectory(File.DirApp,"TMP")=False Then
		File.MakeDir(File.DirApp,"TMP")
		File.Copy(File.DirApp,"fisa service 2020.xlsx",File.DirApp&"\TMP",fileName)
	Else
		File.Copy(File.DirApp&"\Template\","fisa service 2020.xlsx",File.DirApp&"\TMP","fisa service 2020.xlsx")
	End If
	wbRep.InitializeExisting(File.DirApp&"\TMP","fisa service 2020.xlsx","",False)
	Dim sheet As PoiSheet=wbRep.GetSheet(0)
	sheet.GetRow(0).GetCell(2).ValueString=lblDenSoc.Text
	sheet.GetRow(1).GetCell(2).ValueString=adresa
	DateTime.DateFormat="dd-MM-yyyy"
	sheet.GetRow(3).GetCell(0).ValueString="Data : "&DATAFS
	sheet.GetRow(5).GetCell(0).ValueString=txtSolicitare.Text
	sheet.GetRow(11).GetCell(0).ValueString=txtRezolvare.Text
'	sheet.GetRow(17).GetCell(0).ValueString=mp.Get("Model")
'	sheet.GetRow(17).GetCell(3).ValueString=mp.Get("Seria")
'	sheet.GetRow(17).GetCell(5).ValueString=mp.Get("AdrInst")
'	sheet.GetRow(17).GetCell(8).ValueString=txtValContract.Text &".00"
'	sheet.GetRow(39).GetCell(0).ValueString="Data :"&DateTime.Date(DateTime.Now)
	wbRep.Save(File.DirApp&"\TMP","fisa service 2020.xlsx")
	wbRep.Close
End Sub
Sub COPIERE_FISIER(numeFolder As String,DATAFS As String)
Dim fileLIst As List=File.ListFiles(File.DirApp&"\TMP")
	For i=0 To fileLIst.Size-1
		Log(fileLIst.get(i))
		Log("C:\My Documents\StartUp\Clienti\"&numeFolder)
		Log(File.DirApp&"\TMP\"&fileLIst.get(i))
		File.Copy(File.DirApp&"\TMP",fileLIst.get(i),"C:\My Documents\StartUp\Clienti\"&numeFolder,DATAFS &" - "&fileLIst.get(i))
		Sleep(1000)
		File.Delete(File.DirApp&"\TMP",fileLIst.get(i))
		fx.ShowExternalDocument(File.GetUri("C:\My Documents\StartUp\Clienti\"&numeFolder,DATAFS&" - "&fileLIst.get(i)))
	Next
End Sub	

Sub cbExternalCustomer_CheckedChange(Checked As Boolean)
	'========================== ADAUGARE TEXT FISCALIZARE ========================================
	If cbExternalCustomer.Checked Then
		Dim txtanterioara As String= txtSolicitare.Text
		txtSolicitare.Text="- INSPECTIE PERIODICA PT CASA DE MARCAT SERIA : "& txtanterioara
		txtRezolvare.Text ="-S-A EFECTUAT INSPECTIA PT CASEI DE MARCAT CU SERIA : "&txtanterioara
	End If
	'=============================================================================================
End Sub

Sub CMBActivitate_SelectedIndexChanged(Index As Int, Value As Object)
	If Index <> -1 Then 
	Dim txtanterioara As String= txtSolicitare.Text
	Select Case Value
		Case "FISCALIZARE"
			txtSolicitare.Text="- FISCALIZARE PT CASA DE MARCAT SERIA : "& txtanterioara
			txtRezolvare.Text ="-S-A EFECTUAT FISCALIZAREA PT CASEI DE MARCAT CU SERIA : "&txtanterioara
		Case "INSPECTIE TEHNICA ANUALA"
			txtSolicitare.Text="- INSPECTIE PERIODICA PT CASA DE MARCAT SERIA : "& txtanterioara
			txtRezolvare.Text ="-S-A EFECTUAT INSPECTIA PT CASEI DE MARCAT CU SERIA : "&txtanterioara
		Case "MODIFICARE PUNCT DE LUCRU"
			txtSolicitare.Text="- MODIFICARE PUNCT DE LUCRU PT CASA DE MARCAT SERIA : "& txtanterioara
			txtRezolvare.Text ="- S-A EFECTUAT MODIFICARE PUNCT DE LUCRU PT CASEI DE MARCAT CU SERIA : "&txtanterioara
		Case "DEFISCALIZARE"
			txtSolicitare.Text="- DEFISCALIZARE PT CASA DE MARCAT SERIA : "& txtanterioara
			txtRezolvare.Text ="-S-A EFECTUAT DEFISCALIZAREA PT CASEI DE MARCAT CU SERIA : "&txtanterioara
	End Select
	End If
End Sub