﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private btnOK As Button
	Private tbl As TableView
	Private txtConfiguratie As TextField
	Private txtDataAviz As TextField
	Private txtDenComerciala As TextField
	Private txtModel As TextField
	Private txtNrAviz As TextField
	Private txtTip As TextField
	Private txtDetinator As TextField
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	Main.mainTBP.LoadLayout("scr_avizDistributie","Avize distributie")
	fill_table(dbFunction.get_tbl_avize)
End Sub

Sub btnOK_Click
	If dbFunction.get_model_exists(txtModel.Text)= True Then 
		fx.Msgbox(Main.MainForm,"Acest model deja exista in baza de data","Eroare introducere date")
		Return
	End If
	If txtConfiguratie.Text="" Then
		fx.Msgbox(Main.MainForm,"Campul configuratie este necompletat","Eroare introducere date")
		Return
	End If
	If txtDataAviz.Text="" Then 
		fx.Msgbox(Main.MainForm,"Campul data aviz este necompletat","Eroare introducere date")
		Return
	End If
	If txtDenComerciala.Text="" Then
		fx.Msgbox(Main.MainForm,"Campul denumire comerciala este necompletat","Eroare introducere date")
		Return
	End If
	If txtDetinator.Text="" Then 
		fx.Msgbox(Main.MainForm,"Campul Detinator aviz este necompletat","Eroare introducere date")
		Return
	End If
	If txtModel.Text="" Then 
		fx.Msgbox(Main.MainForm,"Campul model este necompletat","Eroare introducere date")
		Return
	End If
	If txtNrAviz.Text="" Or IsNumber(txtNrAviz.Text)=False Then 
		fx.Msgbox(Main.MainForm,"Campul Numar aviz este necompletat sau nu are valoare numerica","Eroare introducere date")
		Return
	End If
	If txtTip.Text="" Then 
		fx.Msgbox(Main.MainForm,"Campul tip este necompletat","Eroare introducere date")
		Return
	End If
dbFunction.add_new_modelECR(txtTip.Text,txtModel.Text,txtConfiguratie.Text,txtNrAviz.Text,txtDataAviz.Text,txtDenComerciala.Text,txtDetinator.Text)	
	fill_table(dbFunction.get_tbl_avize)
	clear_fields
End Sub
Sub fill_table(rs As ResultSet)
	tbl.Items.Clear
	tbl.SetColumns(Array As String("Tip","Model","Nr.Aviz","Data Aviz","Den.Comerciala","Detinator","Structura"))
	Do While rs.NextRow
		Dim row(7) As Object
		row(0)= rs.GetString("Tip")
		row(1)=rs.GetString("Model")
		row(2)=rs.GetString("NrAviz")
		row(3)=rs.GetString("DataAviz")
		row(4)=rs.GetString("DenComerciala")
		row(5)=rs.GetString("Detinator")
		row(6)=rs.GetString("Configuratie")
		tbl.Items.Add(row)
	Loop
End Sub
Sub clear_fields
	txtConfiguratie.Text=""
	txtDataAviz.Text=""
	txtDenComerciala.Text=""
	txtDetinator.Text=""
	txtModel.Text=""
	txtNrAviz.Text=""
	txtTip.Text=""
End Sub