﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.1
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private btnPrint As Button
	Private btnGenerare As Button
	Private cmbCautare As ComboBox
	Private lblDenSoc As Label
	Private lblAdrSediu As Label
	Private lblCUI As Label
	Private tbv As TableView
	Private search_field As MiniSearchView
	Private pn_perioada As Pane
	Private pnDateFirma As Pane
	Private DPPanaLa As DatePicker
	Private DPDeLa As DatePicker
	Private txtSolicitare As TextArea
	Private txtDescriere As TextArea
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	Main.mainTBP.LoadLayout("evidenta_fise_service","Evidenta Fise Service")
	cmbCautare.Items.AddAll(Array As String("Denumire Societate","Serie Echipament","Perioada"))
	cmbCautare.Value="Denumire Societate"
	
End Sub

Sub cmbCautare_SelectedIndexChanged(Index As Int, Value As Object)
	clear_fields
	Select Value
	
		Case "Denumire Societate"
			search_field.SetItems(dbFunction.get_lista_societati_from_fisaService)
			pn_perioada.Visible=False
			pnDateFirma.Visible=True
			pnDateFirma.Top=115dip
		Case "Serie Echipament"
			search_field.SetItems(dbFunction.get_lista_serii_from_fisaService)
			pn_perioada.Visible=False
			pnDateFirma.Visible=False
		Case "Perioada"
			pn_perioada.Visible=True
			pn_perioada.Top=115dip
			pnDateFirma.Visible=False
			fill_table_serie(dbFunction.get_fisa_service_from_date("",""))
	End Select

End Sub
Sub clear_fields
	search_field.TextField.Text=""
	tbv.Items.Clear
	lblDenSoc.Text=""
	lblCUI.Text=""
	lblAdrSediu.Text=""
	txtDescriere.Text=""
	txtSolicitare.Text=""
	
End Sub
Sub ShowResult(item As Object)
	If cmbCautare.SelectedIndex<>-1 Then
		Dim m As MSVItemData=item
		Log(m.Item)
		tbv.Items.Clear
		If cmbCautare.SelectedIndex<>-1 Then
			Select cmbCautare.Value
				Case "Denumire Societate"
					fill_table_societati(dbFunction.get_all_fisa_service("",m.Item))
				Case "Serie Echipament"
					fill_table_serie(dbFunction.get_all_fisa_service(m.Item,""))
			End Select
		End If
		'fill_table(m.Item)
	Else
		fx.Msgbox(Main.MainForm,"Nu ai selectat criteriul de cautare","Eroare operare")
	End If
End Sub
Sub btnGenerare_Click
	DateTime.DateFormat="yyyy-MM-dd"
	fill_table_serie( dbFunction.get_fisa_service_from_date(DateTime.Date(DPDeLa.DateTicks),DateTime.Date(DPPanaLa.DateTicks)))

End Sub
Sub generare_raport(tv As TableView,titlu As String)
	Dim wb As PoiWorkbook
	wb.InitializeNew(True) 'create new xlsx workbook
	Dim sheet1 As PoiSheet = wb.AddSheet("Sheet 1", 0)
	sheet1.AddMergedRegion(0, 0, tv.ColumnsCount-1, 0)
	Dim row As PoiRow = sheet1.CreateRow(0)
	Dim cell As PoiCell = row.CreateCellString(0, titlu)
	Dim cs As PoiCellStyle
	cs.Initialize(wb)
	cs.HorizontalAlignment = cs.HORIZONTAL_CENTER
	cell.CellStyle = cs
	Dim titleStyle As PoiCellStyle
	titleStyle.Initialize(wb)
	titleStyle.BorderBottom = titleStyle.BORDER_THIN
	titleStyle.ForegroundColor = fx.Colors.LightGray
	titleStyle.HorizontalAlignment = titleStyle.HORIZONTAL_CENTER
	Dim font As PoiFont
	font.Initialize(wb)
	font.Bold = True
	titleStyle.SetFont(font)
	'====================== CEREAZA HEADER TABEL EXCEL IN TABLE VIEW ================================
	Dim titleRow As PoiRow = sheet1.CreateRow(1) 'second row
	For tvh=0 To tv.ColumnsCount-1
		titleRow.CreateCellString(tvh,tv.GetColumnHeader(tvh))	
	Next
	'================================================================================================
'	titleRow.CreateCellString(0, "Name")
'	titleRow.CreateCellString(1, "Price")
'	titleRow.CreateCellString(2, "Amount")
'	titleRow.CreateCellString(3, "Total (formula)")
	sheet1.SetColumnWidth(0, 256*20)
	sheet1.SetColumnWidth(1, 256*10)
	sheet1.SetColumnWidth(2, 256*10)
	sheet1.SetColumnWidth(3, 256*20)
	sheet1.SetColumnWidth(4, 256 * 30)
	SetStyleToRowCells(titleRow, titleStyle)
	Dim priceStyle As PoiCellStyle
	priceStyle.Initialize(wb)
	priceStyle.SetDataFormat(wb, "$0.00")
	Dim CELLSTYLA As PoiCellStyle
	CELLSTYLA.Initialize(wb)
	CELLSTYLA.BorderBottom=CELLSTYLA.BORDER_THIN
	CELLSTYLA.HorizontalAlignment=CELLSTYLA.HORIZONTAL_CENTER
	CELLSTYLA.VerticalAlignment=CELLSTYLA.VERTICAL_CENTER
	CELLSTYLA.WrapText=True
	Dim i As Int =0
	For Each tvrow() As Object In tv.Items
		Log(tvrow(0))
		Dim row As PoiRow = sheet1.CreateRow(i + 2)
		For c=0 To tv.ColumnsCount-1
			Dim content As String=tvrow(c)
			If IsNumber(content)=False Then
				row.CreateCellString(c,tvrow(c))
			Else
				row.CreateCellNumeric(c,tvrow(c))
			End If
			'If content.Length>10 Then
			row.GetCell(c).CellStyle=CELLSTYLA
			'End If
'		row.CreateCellString(0, "Itemxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx " & i)
'		row.CreateCellNumeric(1, i)
'		row.CreateCellNumeric(2, i + 1)
'		row.CreateCellFormula(3, $"C${i + 3} * D${i + 3}"$)
'		row.GetCell(0).CellStyle=CELLSTYLA
'		row.GetCell(1).CellStyle = priceStyle
'		row.GetCell(3).CellStyle = priceStyle
		Next
		i=i+1
	Next
	'add image to the workbook
'	Dim imageIndex As Int = wb.AddImage(File.DirAssets, "smiley.png")
	'put the image on the sheet
'	sheet1.SetImage(imageIndex, 5, 5, 7, 8)
'	sheet1.SetImage(imageIndex, 5, 9, 7, 12)
	wb.Save(File.DirApp, "1.xlsx")
	wb.Close
End Sub

' EXPORT DATE PT FISE DE SERVICE - PE SOCIETATE COMERCIALA ( 4 COLOANE )
Sub generare_raport_societate(tv As TableView,societate As String,cui As String,adresa As String)
	
	Dim wb As PoiWorkbook
	wb.InitializeNew(True) 'create new xlsx workbook
	Dim sheet1 As PoiSheet = wb.AddSheet("Sheet 1", 0)
	Dim font As PoiFont
	font.Initialize(wb)
	font.Bold = True
	
	sheet1.AddMergedRegion(0, 0, tv.ColumnsCount-1, 0)
	Dim titlerow As PoiRow = sheet1.CreateRow(0)
	Dim cell As PoiCell = titlerow.CreateCellString(0, "RAPORT FISE SERVICE SOCIETATE")
	
	sheet1.AddMergedRegion(0, 1, tv.ColumnsCount-1, 1)
	Dim denSoc As PoiRow=sheet1.CreateRow(1)
	Dim cellDenSoc As PoiCell = denSoc.CreateCellString(0,"Beneficiar : "&societate)
	
	sheet1.AddMergedRegion(0, 2, tv.ColumnsCount-1, 2)
	Dim rcui As PoiRow=sheet1.CreateRow(2)
	Dim cellCUI As PoiCell = rcui.CreateCellString(0,"CUI : "&cui)
	
	sheet1.AddMergedRegion(0, 3, tv.ColumnsCount-1, 3)
	Dim radresa As PoiRow=sheet1.CreateRow(3)
	Dim celladresa As PoiCell = radresa.CreateCellString(0,"Adresa : "&adresa)
	
	
	Dim cs As PoiCellStyle
	cs.Initialize(wb)
	cs.HorizontalAlignment = cs.HORIZONTAL_CENTER
	cell.CellStyle = cs
	Dim titleStyle As PoiCellStyle
	titleStyle.Initialize(wb)
	titleStyle.BorderBottom = titleStyle.BORDER_THIN
	titleStyle.ForegroundColor = fx.Colors.LightGray
	titleStyle.HorizontalAlignment = titleStyle.HORIZONTAL_CENTER
	
	
	titleStyle.SetFont(font)
	'====================== CEREAZA HEADER TABEL EXCEL IN TABLE VIEW ================================
	Dim titlerow As PoiRow = sheet1.CreateRow(4) 'second row
	For tvh=0 To tv.ColumnsCount-1
		titlerow.CreateCellString(tvh,tv.GetColumnHeader(tvh))
	Next
	'================================================================================================
'	titleRow.CreateCellString(0, "Name")
'	titleRow.CreateCellString(1, "Price")
'	titleRow.CreateCellString(2, "Amount")
'	titleRow.CreateCellString(3, "Total (formula)")
	
	sheet1.SetColumnWidth(0, 256*10)
	sheet1.SetColumnWidth(1, 256*15)
	sheet1.SetColumnWidth(2, 256*20)
	sheet1.SetColumnWidth(3, 256 * 40)
	SetStyleToRowCells(titlerow, titleStyle)
	Dim priceStyle As PoiCellStyle
	priceStyle.Initialize(wb)
	priceStyle.SetDataFormat(wb, "$0.00")
	Dim CELLSTYLA As PoiCellStyle
	CELLSTYLA.Initialize(wb)
	CELLSTYLA.BorderBottom=CELLSTYLA.BORDER_THIN
	CELLSTYLA.HorizontalAlignment=CELLSTYLA.HORIZONTAL_CENTER
	CELLSTYLA.VerticalAlignment=CELLSTYLA.VERTICAL_CENTER
	CELLSTYLA.WrapText=True
	Dim i As Int =3
	For Each tvrow() As Object In tv.Items
		'Log(tvrow(0))
		Dim row As PoiRow = sheet1.CreateRow(i + 2)
		For c=0 To tv.ColumnsCount-1
			Dim content As String=tvrow(c)
			If IsNumber(content)=False Then
				row.CreateCellString(c,tvrow(c))
			Else
				row.CreateCellNumeric(c,tvrow(c))
			End If
			'If content.Length>10 Then
				row.GetCell(c).CellStyle=CELLSTYLA
			'End If
'		
		Next
		i=i+1
	Next

	wb.Save(File.DirApp, "1.xlsx")
	wb.Close
End Sub

Private Sub SetStyleToRowCells(row As PoiRow, style As PoiCellStyle)
	For Each cell As PoiCell In row.Cells
		cell.CellStyle = style
	Next
End Sub
Sub btnPrint_Click
	If tbv.Items.Size<=0 Then 
		fx.Msgbox(Main.MainForm,"NU EXISTA DATE ! ! ! ","Eroare operare")
		Return
	End If
	If cmbCautare.Value="Denumire Societate" Then
	generare_raport_societate(tbv,lblDenSoc.Text,lblCUI.Text,lblAdrSediu.Text)
	Else
	generare_raport(tbv,"RAPORT : "&cmbCautare.Value)
	End If
	Sleep(100)
	fx.ShowExternalDocument(File.GetUri(File.DirApp, "1.xlsx"))
	'mPdf.Create_table_report("Raport Evidenta",tbv,"x","y")
End Sub
' colsfor poate lua valori :
' societati ; serie ; data 
Sub fill_table_societati(RS As ResultSet)
	tbv.Items.Clear
	tbv.SetColumns(Array As String("Id.Fisa","Data Interventie","Solicitare","Descriere"))
	Do While RS.NextRow
		Dim row(4) As Object
		lblDenSoc.Text=RS.GetString("DenumireSocietate")
		lblCUI.Text=RS.GetString("CUI")
		lblAdrSediu.Text=RS.GetString("AdrSediu")
		row(0)=RS.GetString("idFisa")
		row(1)=RS.GetString("data_interventie")
		row(2)=RS.GetString("solicitare")
		row(3)=RS.GetString("descriere")
		tbv.Items.Add(row)
	Loop
End Sub
Sub fill_table_serie(rs As ResultSet)
	tbv.Items.Clear
	tbv.SetColumns(Array As String("Den.Societate","Id.Fisa","Data Interventie","Solicitare","Descriere"))
	Do While rs.NextRow
		Dim row(5) As Object
		row(0)=rs.GetString("DenumireSocietate")
		row(1)=rs.GetString("idFisa")
		row(2)=rs.GetString("data_interventie")
		row(3)=rs.GetString("solicitare")
		row(4)=rs.GetString("descriere")		
		tbv.Items.Add(row)	
	Loop
End Sub

Sub tbv_SelectedRowChanged(Index As Int, Row() As Object)
	If Index<>-1 Then
		If cmbCautare.Value="Denumire Societate" Then
			txtSolicitare.Text=Row(2)
			txtDescriere.Text=Row(3)
		Else
			txtSolicitare.Text=Row(3)
			txtDescriere.Text=Row(4)
		End If
	End If
End Sub