﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private xui As XUI
	Private B4XBtn_aplica As B4XButton
	Private B4XCPTO As B4XCalendarPicker
	Private B4XCPFROM As B4XCalendarPicker
	Private TV As TableView
	Private B4XBtnPDF As B4XButton
	Private btn1 As Button
	Private TV_cumulat As TableView

	'Private BarChart2 As xChart
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	Main.mainTBP.LoadLayout("RAP_CLIENTI","Raport Clienti")
	TV.Items.Clear
	TV.SetColumns(Array As String("Den.Societate","CUI","Adr.Sediu","Data Vanz.","Data Instalare","Adr.Instalare","Serie Echip.","NUI","Model"))
	
End Sub

Sub B4XCPFROM_Click
	
End Sub

Sub B4XCPTO_Click
	
End Sub

Sub B4XBtn_aplica_OneClick
	Dim vanzariPEluni As ResultSet
	DateTime.DateFormat="yyyy-MM-dd"
	Log(DateTime.Date( B4XCPFROM.Date))
	fillTable(dbFunction.raportVanzari(DateTime.Date(B4XCPFROM.Date),DateTime.Date(B4XCPTO.Date)))
	vanzariPEluni=dbFunction.raportVanzari_cumulat_pe_luni(DateTime.Date(B4XCPFROM.Date),DateTime.Date(B4XCPTO.Date))
	fill_tv_cumulat(vanzariPEluni)
	'CreateSingleBarData
End Sub
Sub fillTable(rs As ResultSet)
	TV.Items.Clear
	TV.SetColumns(Array As String("Den.Societate","CUI","Adr.Sediu","Data Vanz.","Data Instalare","Adr.Instalare","Serie Echip.","NUI","Model"))
	Do While rs.NextRow
		Dim row(9) As Object
		row(0)=rs.GetString("DenumireSocietate")
		row(1)=rs.GetString("CIF")
		row(2)=rs.GetString("AdrSediu")
		row(3)=rs.GetString("dataVanzare")
		row(4)=rs.GetString("dataInstalare")
		row(5)=rs.GetString("AdresaFiliala")
		row(6)=rs.GetString("Seria")
		row(7)=rs.GetString("NUI")
		row(8)=rs.GetString("Model")
		TV.Items.Add(row)
	Loop
End Sub
Sub fill_tv_cumulat(rs As ResultSet)
	TV_cumulat.Items.Clear
	TV_cumulat.SetColumns(Array As String("Nr.Vandure","Luna","Anul"))
	Do While rs.NextRow
		Dim AnLuna() As String=Regex.Split("\.",rs.GetString("luna"))
		Dim an As Int
		Dim row(3) As Object
		row(0)=rs.GetString("buc")
		'Log(rs.GetString("luna"))
		'AnLuna=
		'Log(Regex.Split("\.",rs.GetString("luna"))(0))
		'Log(Regex.Split("\.",rs.GetString("luna"))(1))
		row(1)=AnLuna(1)
		an=AnLuna(0)
		If an>0 Then 
			row(2)="20"& AnLuna(0)
		Else 
			row(2)="19"&AnLuna(0)	
		End If
		
		
		TV_cumulat.Items.Add(row)
	Loop
	
End Sub
Sub B4XBtnPDF_OneClick
	'mPdf.Create_table_report("RPT",TV,"","Raport Vanzare / Instalare")
	If File.Exists(File.DirApp, "1.xlsx")=True Then
		File.Delete(File.DirApp, "1.xlsx")
	End If
	CreateWorkbook(dbFunction.raportVanzari(DateTime.Date(B4XCPFROM.Date),DateTime.Date(B4XCPTO.Date)))
	fx.ShowExternalDocument(File.GetUri(File.DirApp, "1.xlsx"))
End Sub
Private Sub CreateWorkbook(rs As ResultSet)
	Dim wb As PoiWorkbook
	wb.InitializeNew(True) 'create new xlsx workbook
	Dim sheet1 As PoiSheet = wb.AddSheet("Sheet 1", 0)
	sheet1.AddMergedRegion(1, 0, 4, 0)
	Dim row As PoiRow = sheet1.CreateRow(0)
	Dim cell As PoiCell = row.CreateCellString(1, "Raport Vanzari")
	Dim cs As PoiCellStyle
	cs.Initialize(wb)
	cs.HorizontalAlignment = cs.HORIZONTAL_CENTER
	cell.CellStyle = cs
	Dim titleStyle As PoiCellStyle
	titleStyle.Initialize(wb)
	titleStyle.BorderBottom = titleStyle.BORDER_THIN
	titleStyle.ForegroundColor = fx.Colors.LightGray
	titleStyle.HorizontalAlignment = titleStyle.HORIZONTAL_CENTER
	Dim font As PoiFont
	font.Initialize(wb)
	font.Bold = True
	titleStyle.SetFont(font)
	Dim titleRow As PoiRow = sheet1.CreateRow(1) 'second row
	titleRow.CreateCellString(1, "Den.Soc.")
	titleRow.CreateCellString(2, "CIF")
	titleRow.CreateCellString(3, "Adr.Sediu")
	titleRow.CreateCellString(4, "Data Vanzare")
	titleRow.CreateCellString(5, "Data Instalare")
	titleRow.CreateCellString(6, "Adresa Pct.Lucru")
	titleRow.CreateCellString(7, "Seria")
	titleRow.CreateCellString(8, "NUI")
	titleRow.CreateCellString(9, "Model")
	'sheet1.SetColumnWidth(4, 256 * 20)
	SetStyleToRowCells(titleRow, titleStyle)
	Dim priceStyle As PoiCellStyle
	priceStyle.Initialize(wb)
	'priceStyle.SetDataFormat(wb, "$0.00")
	'For i = 0 To 25
	Dim  i As Int =0
	Do While rs.NextRow
		Dim row As PoiRow = sheet1.CreateRow(i + 2)
		row.CreateCellString(1, rs.GetString("DenumireSocietate"))
		row.CreateCellstring(2, rs.GetString("CIF"))
		row.CreateCellstring(3, rs.GetString("AdrSediu"))
		row.CreateCellstring(4, rs.GetString("dataVanzare"))
		row.CreateCellstring(5, rs.GetString("dataInstalare"))
		row.CreateCellstring(6, rs.GetString("AdresaFiliala"))
		row.CreateCellstring(7, rs.GetString("Seria"))
		row.CreateCellstring(8, rs.GetString("NUI"))
		row.CreateCellstring(9, rs.GetString("Model"))
		i=i+1
		'row.GetCell(2).CellStyle = priceStyle
		'row.GetCell(4).CellStyle = priceStyle
	Loop
	'Next
	'add image to the workbook
	'Dim imageIndex As Int = wb.AddImage(File.DirAssets, "smiley.png")
	'put the image on the sheet
	'sheet1.SetImage(imageIndex, 5, 5, 7, 8)
	'sheet1.SetImage(imageIndex, 5, 9, 7, 12)
	wb.Save(File.DirApp, "1.xlsx")
	wb.Close
End Sub

Private Sub SetStyleToRowCells(row As PoiRow, style As PoiCellStyle)
	For Each cell As PoiCell In row.Cells
		cell.CellStyle = style
	Next
End Sub
'Private Sub CreateSingleBarData
'	' set the bar color
'	BarChart2.ClearData
'	BarChart2.AddBar("Bar 1", xui.Color_Red)
'	BarChart2.XScaleTextOrientation = "VERTICAL"
'	BarChart2.BarValueOrientation = "VERTICAL"
'	BarChart2.ChartBackgroundColor = xui.Color_Transparent
'	BarChart2.GridFrameColor = xui.Color_Black
'	BarChart2.GridColor = xui.Color_White
'	BarChart2.TitleTextColor = xui.Color_Black
'	BarChart2.ScaleTextColor = xui.Color_Black
'	BarChart2.SetBarMeanValueFormat(1, 2, 2, False)
'	BarChart2.Subtitle = "Perioada : "& DateTime.Date(B4XCPFROM.Date)&" : "&DateTime.Date(B4XCPTO.Date)
'	BarChart2.SubitleTextColor = xui.Color_Gray
'	' Add the items.
''	For i = 0 To 8
''''		BarChart2.AddBarPointData(2005 + i, 0)
''''		BarChart2.AddBarPointData(2005 + i, Rnd(-1000, 1500))
''		BarChart2.AddBarPointData(2005 + i, Rnd(0, 1500))
''''		BarChart2.AddBarPointData(2005 + i, Rnd(-1500, 1))
''	Next
'	For Each row() As Object In TV_cumulat.Items
'		BarChart2.AddBarPointData(row(1)&"/"&row(2),row(0))
'		Log(row(0))
'		Log(row(1))
'		Log(row(2))
'	Next
'	BarChart2.DrawChart
'	Private bmp As B4XBitmap
'	Private Out As OutputStream
'	xui.SetDataFolder("ChartsDemo")
'	Out = File.OpenOutput(xui.DefaultFolder, "BarChart.jpg", False)
''	Log(xui.DefaultFolder)
'	bmp = BarChart2.Snapshot
'	bmp.WriteToStream(Out, 100, "JPEG")
'	Out.Close
'End Sub

' ==== = = = =  == = = = == = =  = 	PROCEDURA MODIFICARE FORMAT DATA IN BAZA DE DATE     OPERATIUNE ELECTUATA IN 08.02.2020

'Sub btn1_Click
'	Dim rs As ResultSet=dbFunction.all_table
'	Do While rs.NextRow
'		Dim li,lv As Long
'		Log(rs.GetString("RowID"))
'		Log(rs.GetString("dataInstalare"))
'		Log(rs.GetString("dataVanzare"))
'		If rs.GetString("dataINstalare")<>"" Then
'			DateTime.DateFormat="dd.MM.yyyy"
'			Log("Data instalare :"&DateTime.DateParse(	rs.GetString("dataInstalare")))
'			li=DateTime.DateParse(	rs.GetString("dataInstalare"))
'			Log("Data vanzare :"&DateTime.DateParse(	rs.GetString("dataVanzare")))
'			lv=DateTime.DateParse(	rs.GetString("dataVanzare"))
'			DateTime.DateFormat="yyyy-MM-dd"
'			Log("Data Instalare"&DateTime.Date(li))
'			Log("Data vanzare"&DateTime.Date(lv))
'		
'			dbFunction.modifica_data(DateTime.Date(lv),DateTime.Date(li),rs.GetString("RowID"))
'		End If
'	Loop
'End Sub
' ==== = = = =  == = = = == = =  = = = = =  = ==  == =  = = = = === = = == = = = = == = = = == = = =